      subroutine ck_hamil_4s(ckx)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iop,ix,it,ista_i4,iend_i4,jsta_i4,jend_i4,
     &           isx(4),msx(4),nsx(4,4),ksx(4,4)
      integer,allocatable :: kd4t(:),jck(:,:),kck(:,:,:),ick(:)
      real(8) :: xx
      type(ck_h4) :: ckx(nh2+1:nh2+nh4)

C --- INITIALIZATION
      ista_i4=nh2+1
      iend_i4=nh2+nh4
      jsta_i4=nh2+idsh4(myid_dmrg+1)+1
      jend_i4=nh2+idsh4(myid_dmrg+1)+icth4(myid_dmrg+1)
!$OMP PARALLEL WORKSHARE
      isx=0
      ckx(:)%ityp=0
      ckx(:)%ntyp=0
!$OMP END PARALLEL WORKSHARE

C --- CHECK KINDS OF TERMS
      allocate(kd4t(jsta_i4:jend_i4))
!$OMP PARALLEL DO PRIVATE(it)
      do iop=jsta_i4,jend_i4
        kd4t(iop)=0
        if(maxval(hamil(iop)%ihs).lt.iad(1).or.
     &     minval(hamil(iop)%ihs).gt.iad(2)) cycle !BETWEEN SYSTEM AND ENVIRONMENT

        if(nse(1)+nas+nae.ne.iad(2)) then !INFINIT DMRG
          it=0
          do ix=1,4
            if(hamil(iop)%ihs(ix).gt.iad(1).and.
     &         hamil(iop)%ihs(ix).lt.iad(2)) then
              it=1; exit
            end if
          enddo
          if(it.eq.1) cycle
        end if

        if(hamil(iop)%ihs(1).eq.hamil(iop)%ihs(2).and.  !(12)-(34)
     &     hamil(iop)%ihs(3).eq.hamil(iop)%ihs(4)) then !Coulomb interactions
          kd4t(iop)=1
        elseif(hamil(iop)%ihs(1).eq.hamil(iop)%ihs(2).and.
     &         hamil(iop)%ihs(2).eq.hamil(iop)%ihs(3).or.     !(123)-(4)
     &         hamil(iop)%ihs(1).eq.hamil(iop)%ihs(2).and.
     &         hamil(iop)%ihs(2).eq.hamil(iop)%ihs(4).or.     !(3)-(124)
     &         hamil(iop)%ihs(1).eq.hamil(iop)%ihs(3).and.
     &         hamil(iop)%ihs(3).eq.hamil(iop)%ihs(4).or.     !(134)--(2)
     &         hamil(iop)%ihs(2).eq.hamil(iop)%ihs(3).and.
     &         hamil(iop)%ihs(3).eq.hamil(iop)%ihs(4)) then   !(1)--(234)
          kd4t(iop)=2
        elseif(hamil(iop)%ihs(1).eq.hamil(iop)%ihs(3).and.
     &         hamil(iop)%ihs(2).eq.hamil(iop)%ihs(4)) then   !(13)--(24)
          kd4t(iop)=3
        elseif(hamil(iop)%ihs(1).eq.hamil(iop)%ihs(2).or.     !(12)--(3)--(4)
     &         hamil(iop)%ihs(3).eq.hamil(iop)%ihs(4)) then   !(1)--(2)--(34)
          kd4t(iop)=4
        elseif(hamil(iop)%ihs(2).eq.hamil(iop)%ihs(3).or.     !(1)--(23)--(4)
     &         hamil(iop)%ihs(1).eq.hamil(iop)%ihs(3)) then   !(13)--(2)--(4)
          kd4t(iop)=5
        elseif(hamil(iop)%ihs(2).eq.hamil(iop)%ihs(4)) then   !(1)-(24)-(3)
          kd4t(iop)=6
        else
          kd4t(iop)=7
        end if
      enddo
      call mpi_allgatherv(kd4t,icth4(myid_dmrg+1),mpi_integer,
     &                    kd4,icth4,idsh4,mpi_integer,
     &                    newcomm_dmrg,ierr)
      deallocate(kd4t)

C --- CHECK SITES IN 2-ELECTRON TERMS
      allocate(ick(61),jck(nsite,30),kck(nsite,nsite,14))
      do ix=1,2
!$OMP PARALLEL WORKSHARE
        jck=0; kck=0; ick=0
!$OMP END PARALLEL WORKSHARE
        do iop=ista_i4,iend_i4
          if(ix.eq.1) then
            allocate(ckx(iop)%num(0:4))
            if(kd4(iop).eq.0) then
              ckx(iop)%num=0
              cycle
            else
              ckx(iop)%num=1
            end if
          elseif(ix.eq.2) then
            if(kd4(iop).eq.0) cycle
            allocate(ckx(iop)%ist(ckx(iop)%num(0),1))
            if(ckx(iop)%num(0).eq.1) then
c              if(kd4(iop).ne.1) then
c              write(6,'(9I5)') kd4(iop),hamil(iop)%ihs,msx
c              end if
              ckx(iop)%ist(1,1)=iop
              cycle
            end if
          end if

          if(kd4(iop).eq.1) cycle !removing Coulomb int.

              cycle ! in order to calculate each terms separately

          call check_op(4,hamil(iop)%ihs,isx,msx,nsx,ksx,xx)

          if(msx(4).eq.0) then
            if(msx(3).eq.0) then
              if(msx(2).eq.1) then     !(sys.B):3--(sys.A):1
                if(kd4(iop).eq.2) then
                  call ck4_ba(ix,iop,ick(1),ckx,1)
                elseif(kd4(iop).eq.4) then
                  call ck4_ba(ix,iop,ick(2),ckx,1)
                elseif(kd4(iop).eq.5) then
                  call ck4_ba(ix,iop,ick(3),ckx,1)
                elseif(kd4(iop).eq.7) then
                  call ck4_ba(ix,iop,ick(4),ckx,1)
                end if
              elseif(msx(2).eq.2) then     !(sys.B):2--(sys.A):2
                if(kd4(iop).eq.3) then
                  call ck4_ba(ix,iop,ick(5),ckx,0)
                elseif(kd4(iop).eq.4) then
                  call ck4_ba(ix,iop,ick(6),ckx,0)
                elseif(kd4(iop).eq.6) then
                  call ck4_ba(ix,iop,ick(7),ckx,0)
                end if
              elseif(msx(2).eq.3) then     !(sys.B):1--(sys.A):3
                if(kd4(iop).eq.2) then
                  call ck4_ba(ix,iop,ick(8),ckx,1)
                elseif(kd4(iop).eq.7) then
                  call ck4_ba(ix,iop,ick(9),ckx,1)
                end if
              end if
            elseif(msx(3).eq.1) then
              if(msx(2).eq.0) then !(sys.B):3--(env.A):1
                if(kd4(iop).eq.2) then
                  call ck4_ba(ix,iop,ick(10),ckx,1)
                elseif(kd4(iop).eq.4) then
                  call ck4_ba(ix,iop,ick(11),ckx,1)
                elseif(kd4(iop).eq.5) then
                  call ck4_ba(ix,iop,ick(12),ckx,1)
                elseif(kd4(iop).eq.6) then
                  call ck4_ba(ix,iop,ick(13),ckx,1)
                elseif(kd4(iop).eq.7) then
                  call ck4_ba(ix,iop,ick(14),ckx,1)
                end if
              elseif(msx(2).eq.1) then !(sys.B):2--(sys.A):1--(env.A):1
                if(kd4(iop).eq.4) then
                  call ck4_ba(ix,iop,ick(15),ckx,0)
                elseif(kd4(iop).eq.5) then
                  call ck4_ba(ix,iop,ick(16),ckx,0)
                elseif(kd4(iop).eq.7) then
                  if(hamil(iop)%ihs(2).gt.hamil(iop)%ihs(4)) then
                    call ck4_ba(ix,iop,ick(17),ckx,0)
                  elseif(hamil(iop)%ihs(2).gt.hamil(iop)%ihs(3)) then
                    call ck4_ba(ix,iop,ick(18),ckx,0)
                  else
                    call ck4_ba(ix,iop,ick(19),ckx,0)
                  end if
                end if
              elseif(msx(2).eq.2) then !(sys.B):1--(sys.A):2--(env.A):1
                if(kd4(iop).eq.4) then
                  call ck4_ba(ix,iop,ick(20),ckx,0)
                elseif(kd4(iop).eq.5) then
                  call ck4_ba(ix,iop,ick(21),ckx,0)
                end if
              elseif(msx(2).eq.3) then !(sys.A):3--(env.A):1
              end if
            elseif(msx(3).eq.2) then 
              if(msx(2).eq.0) then !(sys.B):2--(env.A):2
                if(kd4(iop).eq.3) then
                  call ck4_ba(ix,iop,ick(22),ckx,0)
                elseif(kd4(iop).eq.4) then
                  call ck4_ba(ix,iop,ick(23),ckx,0)
                elseif(kd4(iop).eq.6) then
                  call ck4_ba(ix,iop,ick(24),ckx,0)
                end if
              elseif(msx(2).eq.1) then !(sys.B):1--(sys.A):1--(env.A):2
                if(kd4(iop).eq.4) then
                  call ck4_ba(ix,iop,ick(25),ckx,0)
                elseif(kd4(iop).eq.6) then
                  call ck4_ba(ix,iop,ick(26),ckx,0)
                end if
              elseif(msx(2).eq.2) then !(sys.A):2--(env.A):2
              end if
            elseif(msx(3).eq.3) then
              if(msx(2).eq.0) then !(sys.B):1--(env.A):3
                if(kd4(iop).eq.2) then
                  call ck4_ba(ix,iop,ick(27),ckx,1)
                elseif(kd4(iop).eq.7) then
                  call ck4_ba(ix,iop,ick(28),ckx,1)
                end if
              elseif(msx(2).eq.1) then !(sys.A):1--(env.A):3
              end if
            end if
          elseif(msx(4).eq.1) then
            if(msx(3).eq.0) then
              if(msx(2).eq.0) then !(sys.B):3--(env.B):1
                if(kd4(iop).eq.2) then
                  call ck4_bb1(ix,iop,jck(:,1),msx,ckx,1,1)
                elseif(kd4(iop).eq.4) then
                  call ck4_bb1(ix,iop,jck(:,2),msx,ckx,1,1)
                elseif(kd4(iop).eq.5) then
                  call ck4_bb1(ix,iop,jck(:,3),msx,ckx,1,1)
                elseif(kd4(iop).eq.6) then
                  call ck4_bb1(ix,iop,jck(:,4),msx,ckx,1,1)
                elseif(kd4(iop).eq.7) then
                  call ck4_bb1(ix,iop,jck(:,5),msx,ckx,1,1)
                end if
              elseif(msx(2).eq.1) then !(sys.B):2--(sys.A):1--(env.B):1
                if(kd4(iop).eq.4) then
                  if(nse(2).eq.1) then
                    call ck4_bb1(ix,iop,jck(:,6),msx,ckx,0,2)
                  else
                    call ck4_bb1(ix,iop,jck(:,6),msx,ckx,0,3)
                  end if
                elseif(kd4(iop).eq.5) then
                  call ck4_bb1(ix,iop,jck(:,7),msx,ckx,0,2)
                elseif(kd4(iop).eq.7) then
                  if(hamil(iop)%ihs(2).gt.hamil(iop)%ihs(4)) then
                    call ck4_bb1(ix,iop,jck(:,8),msx,ckx,0,1)
                  elseif(hamil(iop)%ihs(2).gt.hamil(iop)%ihs(3)) then
                    call ck4_bb1(ix,iop,jck(:,9),msx,ckx,0,1)
                  else
                    call ck4_bb1(ix,iop,jck(:,10),msx,ckx,0,1)
                  end if
                end if
              elseif(msx(2).eq.2) then !(sys.B):1--(sys.A):2--(env.B):1
                if(kd4(iop).eq.4) then
                  call ck4_bb1(ix,iop,jck(:,11),msx,ckx,0,1)
                elseif(kd4(iop).eq.5) then
                  call ck4_bb1(ix,iop,jck(:,12),msx,ckx,0,1)
                end if
              elseif(msx(2).eq.3) then !(sys.A):3--(env.B):1
                if(kd4(iop).eq.2) then
                  call ck4_ab(ix,iop,ick(29),ckx,1)
                elseif(kd4(iop).eq.4) then
                  call ck4_ab(ix,iop,ick(30),ckx,1)
                elseif(kd4(iop).eq.5) then
                  call ck4_ab(ix,iop,ick(31),ckx,1)
                elseif(kd4(iop).eq.6) then
                  call ck4_ab(ix,iop,ick(32),ckx,1)
                elseif(kd4(iop).eq.7) then
                  call ck4_ab(ix,iop,ick(33),ckx,1)
                end if
              end if
            elseif(msx(3).eq.1) then
              if(msx(2).eq.0) then !(sys.B):2--(env.A):1--(env.B):1
                if(kd4(iop).eq.4) then
                  if(nse(2).eq.1) then
                    call ck4_bb1(ix,iop,jck(:,13),msx,ckx,0,2)
                  else
                    call ck4_bb1(ix,iop,jck(:,13),msx,ckx,0,3)
                  end if
                elseif(kd4(iop).eq.5) then
                  call ck4_bb1(ix,iop,jck(:,14),msx,ckx,0,1)
                elseif(kd4(iop).eq.7) then
                  if(hamil(iop)%ihs(2).gt.hamil(iop)%ihs(4)) then
                    call ck4_bb1(ix,iop,jck(:,15),msx,ckx,0,1)
                  elseif(hamil(iop)%ihs(2).gt.hamil(iop)%ihs(3)) then
                    call ck4_bb1(ix,iop,jck(:,16),msx,ckx,0,1)
                  else
                    call ck4_bb1(ix,iop,jck(:,17),msx,ckx,0,1)
                  end if
                end if
              elseif(msx(2).eq.1) then !(sys.B):1--(sys.A):1--(env.A):1--(env.B):1
                if(kd4(iop).eq.7) then
                  if(hamil(iop)%ihs(2).gt.hamil(iop)%ihs(4)) then
                    call ck4_bb1(ix,iop,jck(:,18),msx,ckx,0,1)
                  elseif(hamil(iop)%ihs(2).gt.hamil(iop)%ihs(3)) then
                    call ck4_bb1(ix,iop,jck(:,19),msx,ckx,0,1)
                  else
                    call ck4_bb1(ix,iop,jck(:,20),msx,ckx,0,1)
                  end if
                end if
              elseif(msx(2).eq.2) then !(sys.A):2--(env.A):1--(env.B):1
                if(kd4(iop).eq.4) then
                  call ck4_ab(ix,iop,ick(34),ckx,0)
                elseif(kd4(iop).eq.5) then
                  call ck4_ab(ix,iop,ick(35),ckx,0)
                end if
              end if
            elseif(msx(3).eq.2) then
              if(msx(2).eq.0) then !(sys.B):1--(env.A):2--(env.B):1
                if(kd4(iop).eq.4) then
                  call ck4_bb1(ix,iop,jck(:,21),msx,ckx,0,1)
                elseif(kd4(iop).eq.5) then
                  call ck4_bb1(ix,iop,jck(:,22),msx,ckx,0,1)
                end if
              elseif(msx(2).eq.1) then !(sys.A):1--(env.A):2--(env.B):1
                if(kd4(iop).eq.4) then
                  call ck4_ab(ix,iop,ick(36),ckx,0)
                elseif(kd4(iop).eq.5) then
                  call ck4_ab(ix,iop,ick(37),ckx,0)
                end if
              end if
            elseif(msx(3).eq.3) then !(env.A):3--(env.B):1
              if(kd4(iop).eq.2) then
                call ck4_ab(ix,iop,ick(38),ckx,1)
              elseif(kd4(iop).eq.7) then
                call ck4_ab(ix,iop,ick(39),ckx,1)
              end if
            end if
          elseif(msx(4).eq.2) then
            if(msx(3).eq.0) then
              if(msx(2).eq.0) then !(sys.B):2--(env.B):2
                if(kd4(iop).eq.3) then
                  call ck4_bb2(ix,iop,kck(:,:,1),ckx,0)
                elseif(kd4(iop).eq.4) then
                  call ck4_bb2(ix,iop,kck(:,:,2),ckx,0)
                elseif(kd4(iop).eq.5) then
                  call ck4_bb1(ix,iop,jck(:,23),msx,ckx,0,1)
                elseif(kd4(iop).eq.6) then
                  call ck4_bb2(ix,iop,kck(:,:,3),ckx,0)
                elseif(kd4(iop).eq.7) then
                  if(hamil(iop)%ihs(2).gt.hamil(iop)%ihs(4)) then
                    call ck4_bb2(ix,iop,kck(:,:,4),ckx,0)
                  elseif(hamil(iop)%ihs(2).gt.hamil(iop)%ihs(3)) then
                    call ck4_bb2(ix,iop,kck(:,:,5),ckx,0)
                  else
                    call ck4_bb2(ix,iop,kck(:,:,6),ckx,0)
                  end if
                end if
              elseif(msx(2).eq.1) then !(sys.B):1--(sys.A):1--(env.B):2
                if(kd4(iop).eq.4) then
                  if(nse(2).eq.1) then
                    call ck4_bb1(ix,iop,jck(:,24),msx,ckx,0,2)
                  else
                    call ck4_bb1(ix,iop,jck(:,24),msx,ckx,0,1)
                  end if
                elseif(kd4(iop).eq.6) then
                  call ck4_bb1(ix,iop,jck(:,25),msx,ckx,0,1)
                elseif(kd4(iop).eq.7) then
                  if(hamil(iop)%ihs(2).gt.hamil(iop)%ihs(4)) then
                    call ck4_bb2(ix,iop,kck(:,:,7),ckx,0)
                  elseif(hamil(iop)%ihs(2).gt.hamil(iop)%ihs(3)) then
                    call ck4_bb2(ix,iop,kck(:,:,8),ckx,0)
                  else
                    call ck4_bb2(ix,iop,kck(:,:,9),ckx,0)
                  end if
                end if
              elseif(msx(2).eq.2) then !(sys.A):2--(env.B):2
                if(kd4(iop).eq.3) then
                  call ck4_ab(ix,iop,ick(40),ckx,0)
                elseif(kd4(iop).eq.4) then
                  call ck4_ab(ix,iop,ick(41),ckx,0)
                elseif(kd4(iop).eq.5) then
                  call ck4_ab(ix,iop,ick(42),ckx,0)
                elseif(kd4(iop).eq.6) then
                  call ck4_ab(ix,iop,ick(43),ckx,0)
                end if
              end if
            elseif(msx(3).eq.1) then
              if(msx(2).eq.0) then !(sys.B):1--(env.A):1--(env.B):2
                if(kd4(iop).eq.4) then
                  call ck4_bb2(ix,iop,kck(:,:,10),ckx,0)
                elseif(kd4(iop).eq.6) then
                  call ck4_bb2(ix,iop,kck(:,:,11),ckx,0)
                elseif(kd4(iop).eq.7) then
                  if(hamil(iop)%ihs(2).gt.hamil(iop)%ihs(4)) then
                    call ck4_bb2(ix,iop,kck(:,:,12),ckx,0)
                  elseif(hamil(iop)%ihs(2).gt.hamil(iop)%ihs(3)) then
                    call ck4_bb2(ix,iop,kck(:,:,13),ckx,0)
                  else
                    call ck4_bb2(ix,iop,kck(:,:,14),ckx,0)
                  end if
                end if
              elseif(msx(2).eq.1) then !(sys.A):1--(env.A):1--(env.B):2
                if(kd4(iop).eq.4) then
                  call ck4_ab(ix,iop,ick(44),ckx,0)
                elseif(kd4(iop).eq.6) then
                  call ck4_ab(ix,iop,ick(45),ckx,0)
                elseif(kd4(iop).eq.7) then
                  if(hamil(iop)%ihs(2).gt.hamil(iop)%ihs(4)) then
                    call ck4_ab(ix,iop,ick(46),ckx,0)
                  elseif(hamil(iop)%ihs(2).gt.hamil(iop)%ihs(3)) then
                    call ck4_ab(ix,iop,ick(47),ckx,0)
                  else
                    call ck4_ab(ix,iop,ick(48),ckx,0)
                  end if
                end if
              end if
            elseif(msx(3).eq.2) then !(env.A):2--(env.B):2
              if(kd4(iop).eq.3) then
                call ck4_ab(ix,iop,ick(49),ckx,0)
              elseif(kd4(iop).eq.4) then
                call ck4_ab(ix,iop,ick(50),ckx,0)
              elseif(kd4(iop).eq.5) then
                call ck4_ab(ix,iop,ick(51),ckx,0)
              end if
            end if
          elseif(msx(4).eq.3) then
            if(msx(3).eq.0) then
              if(msx(2).eq.0) then !(sys.B):1--(env.B):3
                if(kd4(iop).eq.2) then
                  call ck4_bb1(ix,iop,jck(:,26),msx,ckx,1,1)
                elseif(kd4(iop).eq.4) then
                  call ck4_bb1(ix,iop,jck(:,27),msx,ckx,1,1)
                elseif(kd4(iop).eq.5) then
                  call ck4_bb1(ix,iop,jck(:,28),msx,ckx,1,1)
                elseif(kd4(iop).eq.6) then
                  call ck4_bb1(ix,iop,jck(:,29),msx,ckx,1,1)
                elseif(kd4(iop).eq.7) then
                  call ck4_bb1(ix,iop,jck(:,30),msx,ckx,1,1)
                end if
              elseif(msx(2).eq.1) then !(sys.A):1--(env.B):3
                if(kd4(iop).eq.2) then
                  call ck4_ab(ix,iop,ick(52),ckx,1)
                elseif(kd4(iop).eq.4) then
                  call ck4_ab(ix,iop,ick(53),ckx,1)
                elseif(kd4(iop).eq.5) then
                  call ck4_ab(ix,iop,ick(54),ckx,1)
                elseif(kd4(iop).eq.6) then
                  call ck4_ab(ix,iop,ick(55),ckx,1)
                elseif(kd4(iop).eq.7) then
                  call ck4_ab(ix,iop,ick(56),ckx,1)
                end if
              end if
            elseif(msx(3).eq.1) then !(env.A):1--(env.B):3
              if(kd4(iop).eq.2) then
                call ck4_ab(ix,iop,ick(57),ckx,1)
              elseif(kd4(iop).eq.4) then
                call ck4_ab(ix,iop,ick(58),ckx,1)
              elseif(kd4(iop).eq.5) then
                call ck4_ab(ix,iop,ick(59),ckx,1)
              elseif(kd4(iop).eq.6) then
                call ck4_ab(ix,iop,ick(60),ckx,1)
              elseif(kd4(iop).eq.7) then
                call ck4_ab(ix,iop,ick(61),ckx,1)
              end if
            end if
          end if

        enddo
      enddo

      deallocate(ick,jck,kck)

      return
      end
