      subroutine copy_block(ise,tb0,tb1)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      type(blocks) :: tb0,tb1
      integer :: ise,ib,ista,iend,lsta,lend,ksta,kend,i,it,isec,
     &           mem0,mem1

      isec=mod(ise,2)+1

      if(allocated(tb1%b)) then
        mem0=0; mem1=0
!$OMP PARALLEL DO REDUCTION(+:mem0,mem1)
        do ib=1,tb1%nbk
          do i=1,nfr
            if(allocated(tb1%b(ib)%s(i)%uv)) then
              mem0=mem0+size(tb1%b(ib)%s(i)%uv)
            end if
          enddo
          if(allocated(tb1%b(ib)%hm)) then
            mem1=mem1+size(tb1%b(ib)%hm)
          end if
        enddo
        mem_uv=mem_uv-mem0
        mem_hm=mem_hm-(1+2*id_hop)*mem1
      end if

      if(allocated(tb1%nud)) deallocate(tb1%nud)
      if(allocated(tb1%b2b)) deallocate(tb1%b2b)
      if(allocated(tb1%size)) deallocate(tb1%size)
      if(allocated(tb1%size0)) deallocate(tb1%size0)
      if(allocated(tb1%sizex)) deallocate(tb1%sizex)
      if(allocated(tb1%stax)) deallocate(tb1%stax)
      if(allocated(tb1%nse)) deallocate(tb1%nse)
      if(allocated(tb1%b)) deallocate(tb1%b)
      if(allocated(tb1%kid)) deallocate(tb1%kid)

      if(allocated(tb1%ista0)) deallocate(tb1%ista0)
      if(allocated(tb1%iend0)) deallocate(tb1%iend0)
      if(allocated(tb1%isize0))
     &  deallocate(tb1%isize0)

      if(allocated(tb1%ista)) deallocate(tb1%ista)
      if(allocated(tb1%iend)) deallocate(tb1%iend)
      if(allocated(tb1%isize))
     &  deallocate(tb1%isize)

      if(allocated(tb1%chbk)) deallocate(tb1%chbk)
      if(allocated(tb1%ichbk)) deallocate(tb1%ichbk)

      allocate(tb1%nud(tb0%nbk,2),
     &         tb1%b2b(tb0%nbk,-1:1,nop),
     &         tb1%size(tb0%nbk),
     &         tb1%size0(tb0%nbk),
     &         tb1%sizex(tb0%nbk,nfr),
     &         tb1%stax(tb0%nbk,nfr),
     &         tb1%b(tb0%nbk),
     &         tb1%nse(tb0%nbk,nfr),
     &         tb1%kid(tb0%nbk),
     &         tb1%ista0(tb0%nbk,2),
     &         tb1%iend0(tb0%nbk,2),
     &         tb1%isize0(tb0%nbk,2),
     &         tb1%ista(tb0%nbk,2),
     &         tb1%iend(tb0%nbk,2),
     &         tb1%isize(tb0%nbk,2),
     &         tb1%chbk(tb0%nbk),
     &         tb1%ichbk(tb0%nbk))

      tb1%nbk=tb0%nbk
      tb1%ndmx=tb0%ndmx
      tb1%isbk=tb0%isbk
      tb1%iebk=tb0%iebk
      tb1%isbk1=tb0%isbk1
      tb1%iebk1=tb0%iebk1
      tb1%isbk2=tb0%isbk2
      tb1%iebk2=tb0%iebk2
      tb1%isbk3=tb0%isbk3
      tb1%iebk3=tb0%iebk3
      tb1%isbk4=tb0%isbk4
      tb1%iebk4=tb0%iebk4

      mem0=0; mem1=0
!$OMP PARALLEL DO PRIVATE(ista,iend,ksta,kend,lsta,lend) 
!$OMP1 REDUCTION(+:mem0,mem1)
      do ib=1,tb0%nbk
        tb1%size0(ib)=tb0%size0(ib)

        tb1%kid(ib)=tb0%kid(ib)

        tb1%ista0(ib,1)=tb0%ista0(ib,1)
        tb1%iend0(ib,1)=tb0%iend0(ib,1)
        tb1%isize0(ib,1)=tb0%isize0(ib,1)

        tb1%ista0(ib,2)=tb0%ista0(ib,2)
        tb1%iend0(ib,2)=tb0%iend0(ib,2)
        tb1%isize0(ib,2)=tb0%isize0(ib,2)

        do it=1,nop
          tb1%b2b(ib,-1,it)=tb0%b2b(ib,-1,it)
        enddo
        do it=1,nop
          tb1%b2b(ib,0,it)=tb0%b2b(ib,0,it)
        enddo
        do it=1,nop
          tb1%b2b(ib,1,it)=tb0%b2b(ib,1,it)
        enddo

        tb1%nud(ib,1)=tb0%nud(ib,1)
        tb1%nud(ib,2)=tb0%nud(ib,2)

        do i=1,nfr
          tb1%nse(ib,i)=tb0%nse(ib,i)
        enddo

        do i=1,nfr
          tb1%sizex(ib,i)=tb0%sizex(ib,i)
          tb1%stax(ib,i)=tb0%stax(ib,i)
        enddo

        tb1%chbk(ib)=tb0%chbk(ib)
        tb1%ichbk(ib)=tb0%ichbk(ib)

        tb1%size=tb0%size

        do it=1,2
          tb1%ista(ib,it)=tb0%ista(ib,it)
          tb1%iend(ib,it)=tb0%iend(ib,it)
          tb1%isize(ib,it)=tb0%isize(ib,it)
        enddo

        allocate(tb1%b(ib)%s(nfr))
        call para_range(1,tb1%size0(ib),np_sys,myid_sys,ista,iend)
        do i=1,nfr
          call para_range(1,tb1%sizex(ib,i),np_env,myid_env,lsta,lend)
          allocate(tb1%b(ib)%s(i)%uv(lsta:lend,ista:iend))
          mem0=mem0+size(tb1%b(ib)%s(i)%uv)
          tb1%b(ib)%s(i)%uv=tb0%b(ib)%s(i)%uv
        enddo

        call para_range(1,tb1%size(ib),np_vec,myid_vec,ista,iend)
        call para_range(ista,iend,np_(isec),myid_(isec),ksta,kend)
        call para_range(1,tb1%size(ib),np_(ise),myid_(ise),lsta,lend)
        if(ise.eq.1) then
          allocate(tb1%b(ib)%hm(lsta:lend,ksta:kend))
        elseif(ise.eq.2) then
          allocate(tb1%b(ib)%hm(ksta:kend,lsta:lend))
        end if
        tb1%b(ib)%hm=tb0%b(ib)%hm
        mem1=mem1+size(tb1%b(ib)%hm)

        if(id_hop.eq.1) then
          if(ise.eq.1) then
            allocate(tb1%b(ib)%hmt(lsta:lend,ksta:kend,2))
          elseif(ise.eq.2) then
            allocate(tb1%b(ib)%hmt(ksta:kend,lsta:lend,2))
          end if
          tb1%b(ib)%hmt=tb0%b(ib)%hmt
        end if

        call para_range(1,tb1%size(ib),np_(ise),myid_(ise),ista,iend)
        call para_range(1,tb1%size(ib),np_(isec),myid_(isec),lsta,lend)
        allocate(tb1%b(ib)%tm(ista:iend,lsta:lend))
        tb1%b(ib)%tm=zero
        do i=max(ista,lsta),min(iend,lend)
          tb1%b(ib)%tm(i,i)=one
        enddo
      enddo

      mem_uv=mem_uv+mem0
      mem_hm=mem_hm+(1+2*id_hop)*mem1

      return
      end
