      subroutine def_parameters()
      use mod_dmrg
      implicit none
      include 'mpif.h'

! --- system parameters
      naddf=2   !1 or 2 (1:single added site)
      id_space=1 !0:unlimited spin-space
      dlim_int=1.d-16

! --- MPI parallelization parameters
      write(pal%interact,'(a)') 'L' !A:all, N:no use, L:large, S:small, D:direct
      write(pal%block,'(a)') 'A'
      write(pal%matrix_env,'(a)') 'S'
      pal%n_interact=min(4,np_dmrg)
      pal%n_block=min(3,np_dmrg)
      pal%n_matrix_env=min(2,np_dmrg)

! --- computational parameters
      id_es=0    !1:show entanglement spectrum

! --- Lanczos parameters
      mab0=12    !truncation number
c      mab0=24    !truncation number
c      mab0=300   !truncation number
      mab1=300   !truncation number of final step of DMRG
      ecv=1.d-12  !convergience condition
      lim_mem=0  !0:keep vector, -1:not keep vector
      w_nz=0.d-2  !weight of noize for wavefunction transformation
      num_eigen=1

! --- DMRG parameters
      etr=0.d-10   !convergience condition
      ls_l=1   !maximum size of left block
      ls_r=1   !maximum size of right block
      iwf=1   !-1:except for first sweep, 0:no W.F. transformation, 1:W.F. transformation
      mh=1   !initial Hilbert space number
      ndmrg_ex=0
      id_fast=1 !1:fast mode

! --- DDMRG parameters
      id_fc=1   !1:A(q)-<A(q)>

! --- tDMRG parameters
      id_multi=1 !1:multi-target in tDMRG
      ns_ech=1   !number of sweeps at each time step
#ifdef cmplx_v
      id_mapping=1     !1:use mapping space
!      id_mapping=0     !1:use mapping space
#else
      id_mapping=0     !1:use mapping space
#endif
      nh=1+id_mapping  !number of Hilbert space

!--- PHYSICAL QUANTITIES
      id_current=1 !1:calculating current (tDMRG)
      id_doublon=1 !1:calculating doublon (tDMRG)

! --- I.O. parameters
      iso=6  !I.O. device number (6:stdout, 7--9:output to file)
      key_rank=0   !rank number of output
      write(dir_out,'(a)') 'OUTPUT/'    !directry name for output data
      if(np_dmrg_r.eq.1) then
        write(file_param,'(a)') 'parameters.txt'   !input file name of parameters
        write(file_preset,'(a)') 'preset.txt'      !input file name of preset
        write(file_ddmrg,'(a)') 'dphys.txt'        !input file name of ddmrg
        write(file_posit,'(a)') 'position.txt'     !input file name of position
        write(file_phys,'(a)') 'phys.txt'          !input file name of physical quantities
        write(file_stout,'(a)') 'stdout.txt'       !output file name
        write(file_input,'(a)') 'si.input'         !input file name of ab-initio
        write(file_mag,'(a)') 'mag.txt'             !input file name of magnetic field
        write(file_ene,'(a)') 'energytest.dat'     !output file name of energy at each step
        write(file_scenario,'(a)') 'scenario.txt'  !input file of tDMRG
        write(file_current,'(a)') 'current.dat'    !output file of current
        write(file_doublon,'(a)') 'doublon.dat'    !output file of doublon
        write(file_es,'(a)') 'ES.dat'              !output file of entanglement spectrum
        write(file_qphys,'(a)') 'qphys.txt'        !input file name of physical quantities
        write(file_phys_op,'(a)') 'phys'           !output file name of physical quantities
        write(file_dphys_op,'(a)') 'dphys.dat'     !output file name of physical quantities
        write(file_qphys_op,'(a)') 'qphys'         !output file name of physical quantities
      elseif(np_dmrg_r.gt.1) then
        write(file_param,'(a,I0,a)') 'parameters',myid_dmrg_r,'.txt'
        write(file_preset,'(a,I0,a)') 'preset',myid_dmrg_r,'.txt'
        write(file_ddmrg,'(a,I0,a)') 'dphys',myid_dmrg_r,'.txt'
        write(file_posit,'(a,I0,a)') 'position',myid_dmrg_r,'.txt'
        write(file_phys,'(a,I0,a)') 'phys',myid_dmrg_r,'.txt'
        write(file_stout,'(a,I0,a)') 'stdout',myid_dmrg_r,'.txt'
        write(file_input,'(a,I0,a)') 'si',myid_dmrg_r,'.input'
        write(file_mag,'(a,I0,a)') 'mag',myid_dmrg_r,'.txt'
        write(file_ene,'(a,I0,a)') 'energytest',myid_dmrg_r,'.dat'
        write(file_scenario,'(a,I0,a)') 'scenario',myid_dmrg_r,'.txt'
        write(file_current,'(a,I0,a)') 'current',myid_dmrg_r,'.dat'
        write(file_doublon,'(a,I0,a)') 'doublon',myid_dmrg_r,'.dat'
        write(file_es,'(a,I0,a)') 'ES',myid_dmrg_r,'.dat'
        write(file_qphys,'(a,I0,a)') 'qphys',myid_dmrg_r,'.txt'
        write(file_phys_op,'(a,I0,a)') 'phys',myid_dmrg_r,'_'
        write(file_dphys_op,'(a,I0,a)') 'dphys',myid_dmrg_r,'.dat'
        write(file_qphys_op,'(a,I0,a)') 'qphys',myid_dmrg_r,'_'
      end if

! --- OPEN STDOUT FILE
      if(myid_dmrg.eq.key_rank.and.iso.gt.6) then
        open(iso,file=file_stout)
      end if

      return
      end
