      subroutine digdm(ise,nx,mhx,istrg,ietrg)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ib,jb,i1,k1,i2,ibx,m,iw,ix1,ix2,ix,ill,ibt,ise,ndimx,
     &           msta,mend,nx,ista,iend,lsta,lend,iv,mts_dm,jsta,jend,
     &           ix1_min,ix1_max,ix2_min,ix2_max,isbkx,iebkx,isize,
     &           jsize,ksize,lsize,ip,mhx,istrg,ietrg,isec,id_abk,ih
      real(8) :: ee,er,DASUM
      real(8),allocatable :: vl(:)
#ifdef timer
      real(8),allocatable :: timed(:),time_res(:)
#endif
#ifdef cmplx_v
      complex(8),
#else
      real(8),
#endif
     &  allocatable :: uv0(:,:),uv1(:,:),vt(:,:)
      integer,allocatable :: idm(:),jdm(:),ibk(:)
      type(temp_array),allocatable :: nb(:)

      ih=1

! --- INITIALIZE REDUCED DENSITY MATRIX
      mts_dm=mts
      iw=0
      isec=mod(ise,2)+1
#ifdef timer
      allocate(timed(0:3))
      timed=0.d0
#endif
      isbkx=isbk1; iebkx=iebk1
      if(nadd.eq.1.and.pvw.gt.1.d-6.and.id_space.eq.1) then
        call adjust_block(block(ise,nx,mhx),ise,nx,id_abk) !expanding spin space
      else
        call save_block(block(ise,nx,mhx),ise)
        id_abk=0
      end if

      if(id_space.eq.0) then
        ndimx=block(ise,nx,mhx)%size0(1)
      else
        ndimx=0
!$OMP PARALLEL DO REDUCTION(+:ndimx)
        do ib=1,nbk
          ndimx=ndimx+block(ise,nx,mhx)%size0(ib)
        enddo
      end if

! --- CASE 1: M > DIMENSION OF BLOCK (INFINIT)
      if(ndimx.le.mts_dm) then
        call alc_uv(1,ise,nx,mhx) !uv:unit_operator
        return

! --- CASE 2
      else
        call alc_uv(0,ise,nx,mhx)
      end if

      allocate(vl(ndimx),nb(1:nbk),
     &         ircnt1(np_(1),nbk),idisp1(np_(1),nbk),
     &         ircnt2(np_(2),nbk),idisp2(np_(2),nbk))
!$OMP PARALLEL WORKSHARE
      vl=0.d0   !REAL(8)
!$OMP END PARALLEL WORKSHARE
      do ib=1,nbk
        call pre_algv2(1,block(ise,nx,mhx)%size0(ib),np_(1),
     &                 ircnt1(:,ib),idisp1(:,ib))
        call pre_algv2(1,block(ise,nx,mhx)%size0(ib),np_(2),
     &                 ircnt2(:,ib),idisp2(:,ib))
        allocate(nb(ib)
     &           %uv(idisp2(myid_(2)+1,ib)+1:
     &               idisp2(myid_(2)+1,ib)+ircnt2(myid_(2)+1,ib),
     &               idisp1(myid_(1)+1,ib)+1:
     &               idisp1(myid_(1)+1,ib)+ircnt1(myid_(1)+1,ib)))
!$OMP PARALLEL WORKSHARE
        nb(ib)%uv=zero
!$OMP END PARALLEL WORKSHARE
      enddo

      ee=0.d0
      do ib=1,nbk !extended nbk
        jb=block(ise,nx,mhx)%chbk(ib)
        if(jb.lt.isbkx.or.jb.gt.iebkx) cycle
        if(block(ise,nx,mhx)%size0(ib).gt.0) then
          do i1=1,nfrx(ise)
            if(block(ise,nx,mhx)%sizex(ib,i1).eq.0) cycle
            call para_ranges(1,block(ise,nx,mhx)%sizex(ib,i1),np_(ise),
     &                       myid_(ise),jsta,jend,jsize)
            do i2=i1,nfrx(ise)
              if(block(ise,nx,mhx)%sizex(ib,i2).eq.0) cycle
              call para_ranges(1,block(ise,nx,mhx)%sizex(ib,i2),
     &                         np_(ise),myid_(ise),ista,iend,isize)
              allocate(uv0(block(ise,nx,mhx)%sizex(ib,i1),isize))
              iw=0; ix=0
#ifdef timer
              timed(0)=mpi_wtime()
#endif
              do k1=1,nfrx(mod(ise,2)+1)
                if(bk(jb,mod(ise,2)+1,ih)%sizex(k1).gt.0) then
                  ksize=bk(jb,isec,ih)%ive(k1)-bk(jb,isec,ih)%ivs(k1)+1
                  lsize=ksize*isize
                  if(ise.eq.1) then !SYSTEM
                    allocate(vt(block(ise,nx,mhx)%sizex(ib,i1),ksize))
                    do iv=istrg,ietrg !iv:target state number
                      call gc2d(v(jb,iv)%ap(ad(i1,k1))%b,jsize,ksize,
     &                          vt,block(ise,nx,mhx)%sizex(ib,i1),
     &                          np_(ise),newcomm_(ise))
                      if(lsize.gt.0) then
                        call XGEMM(chmm(1),chmm(2),
     &                             block(ise,nx,mhx)%sizex(ib,i1),
     &                             isize,
     &                             ksize,
     &                             one,
     &                             vt,
     &                             block(ise,nx,mhx)%sizex(ib,i1),
     &                             v(jb,iv)%ap(ad(i2,k1))%b,
     &                             isize,
     &                             ix*one,
     &                             uv0,
     &                             block(ise,nx,mhx)%sizex(ib,i1))
                        ix=1
                      end if
                    enddo
                  elseif(ise.eq.2) then !ENVIRONMENT
                    allocate(vt(ksize,block(ise,nx,mhx)%sizex(ib,i1)))
                    do iv=istrg,ietrg !iv:target state number
                      call gr2d(v(jb,iv)%ap(ad(k1,i1))%b,ksize*jsize,
     &                          vt,np_(ise),newcomm_(ise))
                      if(lsize.gt.0) then
                        call XGEMM(chmm(2),chmm(1),
     &                             block(ise,nx,mhx)%sizex(ib,i1),
     &                             isize,
     &                             ksize,
     &                             one,
     &                             vt,
     &                             ksize,
     &                             v(jb,iv)%ap(ad(k1,i2))%b,
     &                             ksize,
     &                             ix*one,
     &                             uv0,
     &                             block(ise,nx,mhx)%sizex(ib,i1))
                        ix=1
                      end if
                    enddo
                  end if
                  deallocate(vt)
                  iw=1
                end if
              enddo
#ifdef timer
              timed(2)=timed(2)+(mpi_wtime()-timed(0))
#endif
              if(ix.eq.0) then
!$OMP PARALLEL WORKSHARE
                uv0=zero
!$OMP END PARALLEL WORKSHARE
              end if
#ifdef timer
              timed(0)=mpi_wtime()
#endif
              if(ise.eq.1) then !SYSTEM
                if(iw.eq.1) then
                  allocate(uv1(block(ise,nx,mhx)%stax(ib,i1):
     &                         block(ise,nx,mhx)%stax(ib,i1)
     &                        +block(ise,nx,mhx)%sizex(ib,i1)-1,isize))

                  call mpi_allreduce(uv0,uv1,
     &                     block(ise,nx,mhx)%sizex(ib,i1)*isize,
     &                     mpi_kv,mpi_sum,newcomm_(isec),ierr)

                  deallocate(uv0)

                  call mpi_ixbd(block(ise,nx,mhx),ib,i1,i2,ix1_min,
     &                          ix1_max,ix2_min,ix2_max)

                  allocate(uv0(ix1_min:ix1_max,isize))

!$OMP PARALLEL DO
                  do ix2=1,isize
                    do ix1=ix1_min,ix1_max
                      uv0(ix1,ix2)=uv1(ix1,ix2)
                    enddo
                  enddo

                  deallocate(uv1)

                  allocate(uv1(ix1_min:ix1_max,
     &                         block(ise,nx,mhx)%stax(ib,i2):
     &                         block(ise,nx,mhx)%stax(ib,i2)
     &                        +block(ise,nx,mhx)%sizex(ib,i2)-1))

                  call gr2d(uv0,size(uv0),uv1,np_(ise),newcomm_(ise))

!$OMP PARALLEL DO
                  do ix2=ix2_min,ix2_max
                    do ix1=ix1_min,ix1_max
                      nb(ib)%uv(ix1,ix2)=nb(ib)%uv(ix1,ix2)+uv1(ix1,ix2)
                    enddo
                  enddo
                  deallocate(uv1)
                end if
                deallocate(uv0)

              else !ENVIRONMENT
                if(iw.eq.1) then
                  allocate(uv1(block(ise,nx,mhx)%sizex(ib,i1),isize))

                  call mpi_allreduce(uv0,uv1,
     &                     block(ise,nx,mhx)%sizex(ib,i1)*isize,
     &                     mpi_kv,mpi_sum,newcomm_(isec),ierr)

                  deallocate(uv0)

                  allocate(uv0(block(ise,nx,mhx)%stax(ib,i1):
     &                         block(ise,nx,mhx)%stax(ib,i1)
     &                        +block(ise,nx,mhx)%sizex(ib,i1)-1,
     &                         block(ise,nx,mhx)%stax(ib,i2):
     &                         block(ise,nx,mhx)%stax(ib,i2)
     &                        +block(ise,nx,mhx)%sizex(ib,i2)-1))

                  call gr2d(uv1,block(ise,nx,mhx)%sizex(ib,i1)*isize,
     &                      uv0,np_(ise),newcomm_(ise))

                  deallocate(uv1)

                  call mpi_ixbd(block(ise,nx,mhx),ib,i1,i2,ix1_min,
     &                          ix1_max,ix2_min,ix2_max)
!$OMP PARALLEL DO
                  do ix2=ix2_min,ix2_max
                    do ix1=ix1_min,ix1_max
                      nb(ib)%uv(ix1,ix2)=nb(ib)%uv(ix1,ix2)+uv0(ix1,ix2)
                    enddo
                  enddo
                end if
                deallocate(uv0)
              end if
#ifdef timer
              timed(3)=timed(3)+(mpi_wtime()-timed(0))
#endif
            enddo
          enddo
        end if
      enddo

      if(id_abk.eq.1) then
        do ib=1,nbk
          jb=block(ise,nx,mhx)%chbk(ib)
          if(jb.eq.0) cycle
          if(kid_old(jb,1).eq.myid_bk) then
            call mpi_bcast(nb(ib)%uv,
     &                     ircnt2(myid_(2)+1,ib)*ircnt1(myid_(1)+1,ib),
     &                     mpi_kv,kid_old(jb,2),newcomm_int,ierr)
          end if
          call mpi_bcast(nb(ib)%uv,
     &                   ircnt2(myid_(2)+1,ib)*ircnt1(myid_(1)+1,ib),
     &                   mpi_kv,kid_old(jb,1),newcomm_bk,ierr)
        enddo

        call ex_space(nb,ise,block(ise,nx,mhx)) !extend spin space for single added site DMRG
      end if

c      allocate(time_test(2)) !test
c      time_test(2)=0.d0 !test

      do ib=isbk1,iebk1
        m=block(ise,nx,mhx)%size0(ib)
        allocate(idm(m))
        do i1=1,nfrx(ise)
!$OMP PARALLEL DO
          do ibx=block(ise,nx,mhx)%stax(ib,i1),
     &           block(ise,nx,mhx)%stax(ib,i1)
     &             +block(ise,nx,mhx)%sizex(ib,i1)-1
            idm(ibx)=ibx
          enddo
        enddo

        msta=0
!$OMP PARALLEL DO REDUCTION(+:msta)
        do ibt=1,ib-1
          msta=msta+block(ise,nx,mhx)%size0(ibt)
        enddo
        mend=msta+block(ise,nx,mhx)%size0(ib)
        msta=msta+1

        if(mend.ge.msta) then
#ifdef timer
          timed(0)=mpi_wtime()
#endif
          call eigen_calculate(m,ib,nb(ib)%uv,vl(msta:mend),
     &                         block(ise,nx,mhx),ill)
#ifdef timer
          timed(1)=timed(1)+(mpi_wtime()-timed(0))
#endif
          ill=1
          call sortdi(m,vl(msta:mend),idm,ill)
        end if

        call para_range(1,block(ise,nx,mhx)%size0(ib),np_sys,myid_sys,
     &                  ista,iend)

        if(mts_dm.lt.ndimx) then
          allocate(jdm(m))
!$OMP PARALLEL DO
          do ix1=1,m
            jdm(idm(ix1))=ix1
          enddo

          do ip=1,np_(1)
            allocate(uv1(block(ise,nx,mhx)%size0(ib),idisp1(ip,ib)+1:
     &                   idisp1(ip,ib)+ircnt1(ip,ib)))
            if(myid_(1).eq.ip-1) then
              call gc2d(nb(ib)%uv,ircnt2(myid_(2)+1,ib),
     &                  ircnt1(myid_(1)+1,ib),uv1,
     &                  block(ise,nx,mhx)%size0(ib),
     &                  np_(2),newcomm_(2))
            end if
            call mpi_bcast(uv1,block(ise,nx,mhx)%size0(ib)
     &                     *ircnt1(ip,ib),mpi_kv,ip-1,newcomm_(1),ierr)

            do ix1=ista,iend
              if(jdm(ix1).ge.idisp1(ip,ib)+1.and.
     &           jdm(ix1).le.idisp1(ip,ib)+ircnt1(ip,ib)) then
                do i1=1,nfrx(ise)
                  call para_ranges(1,block(ise,nx,mhx)%sizex(ib,i1),
     &                             np_(2),myid_(2),lsta,lend,lsize)
                  if(lsize.gt.0) then
                    call XCOPY(lsize,
     &                     uv1(block(ise,nx,mhx)
     &                       %stax(ib,i1)+lsta-1,jdm(ix1)),
     &                     1,block(ise,nx,mhx)%b(ib)%s(i1)%uv(:,ix1),1)
                  end if
                enddo
              end if
            enddo
            deallocate(uv1)
          enddo
          deallocate(jdm)
        else !NOT TRANSFORM BASIS SET
          do i1=1,nfrx(ise)
            call para_range(1,block(ise,nx,mhx)%sizex(ib,i1),np_env,
     &                      myid_env,lsta,lend)
            call unit_uv(ise,nx,mhx,ib,i1,ista,iend,lsta,lend)
          enddo
        end if

        deallocate(idm)
      enddo

      deallocate(nb,ircnt1,idisp1,ircnt2,idisp2)

      allocate(ibk(ndimx))
      do ib=1,nbk
        jb=block(ise,nx,mhx)%chbk(ib)
        if(block(ise,nx,mhx)%size0(ib).eq.0) cycle
        msta=0
!$OMP PARALLEL DO REDUCTION(+:msta)
        do ibt=1,ib-1
          msta=msta+block(ise,nx,mhx)%size0(ibt)
        enddo
        mend=msta+block(ise,nx,mhx)%size0(ib)
        msta=msta+1
!$OMP PARALLEL WORKSHARE
        ibk(msta:mend)=ib
!$OMP END PARALLEL WORKSHARE
        if(block(ise,nx,mhx)%kid(ib).eq.myid_bk) then
          call mpi_bcast(vl(msta:mend),block(ise,nx,mhx)%size0(ib),
     &                   MPI_REAL8,kid1(ib),newcomm_int,ierr)
        end if

        call mpi_bcast(vl(msta:mend),block(ise,nx,mhx)%size0(ib),
     &                 MPI_REAL8,block(ise,nx,mhx)%kid(ib),newcomm_bk,
     &                 ierr)

! --- DATA SYNCHRONIZATION
        call mpi_bcast(vl(msta:mend),block(ise,nx,mhx)%size0(ib),
     &                 MPI_REAL8,0,newcomm_int,ierr)
        call mpi_bcast(vl(msta:mend),block(ise,nx,mhx)%size0(ib),
     &                 MPI_REAL8,0,newcomm_vec,ierr)
      enddo

      do i1=1,nfrx(ise)
        do ib=isbk0,iebk0
          call para_ranges(1,block(ise,nx,mhx)%size0(ib),np_sys,
     &                     myid_sys,ista,iend,isize)
          call para_ranges(1,block(ise,nx,mhx)%sizex(ib,i1),np_env,
     &                     myid_env,lsta,lend,lsize)
          lsize=lsize*isize
          call mpi_bcast(block(ise,nx,mhx)%b(ib)%s(i1)%uv,lsize,mpi_kv,
     &                   kid1(ib),newcomm_int,ierr)
          call mpi_bcast(block(ise,nx,mhx)%b(ib)%s(i1)%uv,lsize,mpi_kv,
     &                   0,newcomm_vec,ierr)
        enddo
      enddo

      if(np_bk.gt.1) then
        do i1=1,nfrx(ise)
          do ib=1,nbk
            call para_ranges(1,block(ise,nx,mhx)%size0(ib),np_sys,
     &                       myid_sys,ista,iend,isize)
            call para_ranges(1,block(ise,nx,mhx)%sizex(ib,i1),np_env,
     &                       myid_env,lsta,lend,lsize)
            lsize=lsize*isize
            call mpi_bcast(block(ise,nx,mhx)%b(ib)%s(i1)%uv,lsize,
     &                     mpi_kv,block(ise,nx,mhx)%kid(ib),newcomm_bk,
     &                     ierr)
          enddo
        enddo
      end if

      ill=1
      call sortdi(ndimx,vl,ibk,ill)

!$OMP PARALLEL DO REDUCTION(+:ee)
      do ix1=min(mts_dm,ndimx),1,-1
        if(vl(ix1).gt.0.d0) then
          ee=ee-vl(ix1)*log(vl(ix1))
        end if
      enddo

c --- entanglement spectrum
      if(myid_dmrg.eq.key_rank.and.id_es.eq.1) then
        write(iso,'(1x,a)') '- entanglement spectrum (ES) -'
        write(iso,'(1x,a)') '#     <  ES  >       <  EV  >'
        do ix1=1,ndimx
          if(vl(ix1).le.0.d0) exit
          write(iso,'(1x,I0,1x,e14.6,1x,e14.6)') 
     &      ix1,-log(vl(ix1)),vl(ix1)
        enddo
        write(iso,*)
      end if

      if(allocated(ML_label).and.idmrg.eq.ndmrg) then
        open(18,file=file_es,position='append')
        if(np_dmrg_r.eq.1) then
          do ix1=1,mts_dm
            write(18,'(e14.6)',advance='no') -log(vl(ix1))
            if(ix1.eq.mts_dm) then
              write(18,'(a,1x,I0)',advance='no') ',',ML_label
              write(18,*)
              exit
            else
              write(18,'(a)',advance='no') ','
            end if
          enddo
        else
          do ix1=1,mts_dm
            write(18,'(e14.6)',advance='no') -log(vl(ix1))
            if(ix1.eq.mts_dm) then
              write(18,'(a,1x,I0)',advance='no') ' ',ML_label
               write(18,*)
              exit
            else
              write(18,'(a)',advance='no') ' '
            end if
          enddo
        end if
        close(18)
      end if

      if(etr.gt.0.d0) then
        er=1.d0
        do ix1=1,min(mts_dm,ndimx)
          er=er-vl(ix1)
          if(er.lt.etr) then
            ndimx=ix1
            exit
          end if
        enddo
      end if

      er=DASUM(min(mts_dm,ndimx),vl,1)

!$OMP PARALLEL WORKSHARE
      block(ise,nx,mhx)%size=0
!$OMP END PARALLEL WORKSHARE
      do ix1=1,min(mts_dm,ndimx)
        block(ise,nx,mhx)%size(ibk(ix1))
     &    =block(ise,nx,mhx)%size(ibk(ix1))+1
      enddo

      do ib=1,nbk
        do ix1=1,2
          call para_range(1,block(ise,nx,mhx)%size(ib),np_(ix1),
     &                    myid_(ix1),ista,iend)
          block(ise,nx,mhx)%ista(ib,ix1)=ista
          block(ise,nx,mhx)%iend(ib,ix1)=iend
          block(ise,nx,mhx)%isize(ib,ix1)=max(iend-ista+1,0)
        enddo
      enddo

! --- OUTPUT DATA
#ifdef timer
      allocate(time_res(3))
      call mpi_allreduce(timed(1),time_res(1),1,MPI_REAL8,mpi_max,
     &                   newcomm_dmrg,ierr)
      call mpi_allreduce(timed(2),time_res(2),1,MPI_REAL8,mpi_max,
     &                   newcomm_dmrg,ierr)
      call mpi_allreduce(timed(3),time_res(3),1,MPI_REAL8,mpi_max,
     &                   newcomm_dmrg,ierr)
#endif
      if(myid_dmrg.eq.key_rank) then
        if(ise.eq.1) then
          write(iso,'(1x,a)') '# system:'
        elseif(ise.eq.2) then
          write(iso,'(1x,a)') '# environment:'
        end if
        write(iso,'(2x,a,f12.8)') '(entanglement entropy) = ',ee
        write(iso,'(2x,a,I0)') '(DMRG truncation number) = ',
     &                         min(ndimx,mts_dm)
        if(ndimx.gt.mts_dm) then
          write(iso,'(2x,a,1Pe12.5)') '(truncation error) = ',1.d0-er
        else
          write(iso,'(2x,a,1Pe12.5)') '(truncation error) = ',0.d0
        end if
#ifdef timer
        write(iso,'(2x,a,f10.4,a)') 
     &    '(diagonalization):',time_res(1),' [s]'
        write(iso,'(2x,a,f10.4,a)') 
     &    '(M.M. product)   :',time_res(2),' [s]'
        write(iso,'(2x,a,f10.4,a)') 
     &    '(communication)  :',time_res(3),' [s]'
#endif
      end if

      deallocate(vl,ibk)
#ifdef timer
      deallocate(timed,time_res)
#endif

! ---- PRESERVATION DATA
      if(iphys.eq.1) then
c      if(nse(1).eq.nsite/2-1+naddf/2) then
        phys(3)%dsw(icphys)=ee
        phys(4)%dsw(icphys)=1.d0-er
      end if

      ee_t=ee
      err_t=1.d0-er

      return
      end
