      subroutine init_parameters()
      use mod_dmrg
      implicit none
      include 'mpif.h'

! --- INITIALIZE DMRG PARAMETERS
! --- elapsed time
      allocate(time(5),times(5))
      times=0.d0

! --- variable
#ifdef cmplx_v
      mpi_kv=mpi_double_complex
#else
      mpi_kv=mpi_double_precision
#endif

! --- MPI parallelization
      write(pal%vector,'(a)') 'N'
      pal%n_vector=min(2,np_dmrg)

! --- system
      write(boundary,'(a)') 'c'
      id_spin=0
      id_spinless=0
      allocate(nfrx(2),cmag(3))
      cmag=1.d0

! --- memory size
      mem_uv=0   !memory size of 'uv'
      mem_hm=0   !memory size of 'hamiltonian'
      mem_ts=0   !memory size of 'target states'
      mem_op=0   !memory size of 'operators'

! --- energy
      emin_min=1.d306
      emax_max=-emin_min

! --- DMRG
      mts=50   !truncation number
      allocate(nse(2),iad(2))
      nse=(/1,1/)
      mdDMRG=0
      nas=1
      nae=1
      nadd=nas+nae

! --- Dynamical DMRG
      id_ddmrg=0 !1:DDMRG calculation
      if_ddmrg=0 !flag of DDMRG

! --- time-dependent DMRG
      itdmrg=0 !scenario of time dependent DMRG
      ptime=0.d0
      ich_time=0
      if_tdmrg=0 !flag of tDMRG
      iswp_ev=0
      num_ev=0
      id_tdmrg=0 !1:tDMRG calculation
      nsweep_t=0
      itdmrg=1
      id_hop=0
      ndmrg_dt=0

! --- INITIALIZE PARAMETERS
      nsite=0   !number of sites
      nsweep=0   !number of sweeps

! --- (D,Z)GEMM PARAMETERS
#ifdef cmplx_v
      write(chmm(1),'(a)') 'N'
      write(chmm(2),'(a)') 'C'
      write(chmm(3),'(a)') 'T'
#else
      write(chmm(1),'(a)') 'N'
      write(chmm(2),'(a)') 'T'
      write(chmm(3),'(a)') 'T'
#endif

      return
      end
