      subroutine make_hamil()
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iop,iop0,id,ib,isbkx,iebkx
      integer,allocatable :: itmp0(:),itmp1(:),lop(:)

      time(2)=mpi_wtime()

C --- INITIALIZE
      id_mop=1   !1:CHECKING MEMORY USAGE
      if(allocated(th)) deallocate(th)
      if(allocated(kd4)) deallocate(kd4)
      allocate(th(1),ck2(nh2,0:2),ckc(nh2+1:nh2+nh4,0:2),
     &         ck4(nh2+1:nh2+nh4,0:2),kd4(nh2+1:nh2+nh4))

      call ck_hamil_2(ck2)

      if(nh4.gt.0) then
C ----- TWO ELECTRONS TERMS (4 OPERATORS)
        if(id_spin.eq.0) then
          call ck_hamil_c(ckc)
          call ck_hamil_4(ck4(:,0))
C ----- 4-SPIN TERMS (4 OPERATORS)
        else
          call ck_hamil_4s(ck4(:,0))
        end if
      end if

      allocate(lop(0))

      do id=1,2 !1:check number of terms, 2:make operators
        if(id.eq.2) then
          deallocate(lop)
          if(allocated(kop)) deallocate(kop)
          allocate(th(1)%kh(iop0),th(1)%ic(iop0),kop(2,iop0),lop(iop0))
          lop=0

          call para_int(0,iop0)

          if(allocated(pop)) deallocate(pop)
          allocate(pop(4,iop0))

          if(myid_dmrg.eq.0) then
            write(iso,'(2x,a,I0,a,I0,a)')
     &        '(number of long-range terms) = ',iop0,' (/',np_int,')'
          end if
        end if

        iop0=0
C ----- SYSTEM- AND ENVIRONMENT-BLOCKS
        iop0=iop0+1
        if(id.eq.2) then
          call hamil_b(iop0)
        end if

C ----- ONE ELECTRON TERMS (2 OPERATORS)
        do iop=1,nh2
          if(hamil(iop)%ihs(2).lt.iad(1)) cycle
          if(hamil(iop)%ihs(1).gt.iad(2)) cycle
          call hamil_2(id,0,iop,iop0,lop)
        enddo

C ----- TWO ELECTRONS TERMS (4 OPERATORS)
        if(id_spin.eq.0) then
          do iop=nh2+1,nh2+nh4
            if(kd4(iop).eq.0) cycle
            if(ck4(iop,0)%num(0).eq.0) cycle
            call hamil_4(id,iop,iop0,lop)
          enddo
C ----- 4-SPIN TERMS (4 OPERATORS)
        else
          do iop=nh2+1,nh2+nh4
            call hamil_4s(id,iop,iop0,lop)
          enddo
        end if
      enddo

      th(1)%nh=iop0 !number of interactions between system and environment

      do iop=ista_int,iend_int
        if(.not.allocated(kop(2,iop)%jbk)) then
          allocate(kop(2,iop)%jbk(nbk))
          kop(2,iop)%jbk=0
          do ib=1,nbk
            if(kop(1,iop)%jbk(ib).eq.0) cycle
            kop(2,iop)%jbk(kop(1,iop)%jbk(ib))=ib
          enddo
        end if
      enddo

      allocate(th(1)%fst(ista_int:iend_int))
      th(1)%fst=0
!      if(np_mx.eq.1) then
!        call com_int(lop)
!      end if

      deallocate(ck2,ckc,ck4,kd4,lop)

C --- PARALLELIZATION OF BLOCK
      if(allocated(bmpi)) deallocate(bmpi)
      allocate(bmpi(nbk),itmp0(0:nbk),itmp1(nbk))
      itmp0=0
      do iop=ista_int,iend_int
        do ib=isbk0,iebk0
          itmp0(kop(1,iop)%jbk(ib))=1
          itmp0(kop(2,iop)%jbk(ib))=1
        enddo
      enddo

      if(myid_mx.eq.0) then
        call mpi_allreduce(itmp0(1),itmp1,nbk,mpi_integer,mpi_sum,
     &                     newcomm_bk,ierr)
      end if
      call mpi_bcast(itmp1,nbk,mpi_integer,0,newcomm_mx,ierr)

      do ib=1,isbk0-1
        bmpi(ib)%ic=itmp0(ib)
        if(itmp0(ib).eq.1) then
          allocate(bmpi(ib)%id(itmp0(ib)))
          bmpi(ib)%id(1)=kid0(ib)
        end if
      enddo
      do ib=isbk0,iebk0
        bmpi(ib)%ic=itmp1(ib)
        allocate(bmpi(ib)%id(itmp1(ib)))
        bmpi(ib)%id=0
      enddo
      do ib=iebk0+1,nbk
        bmpi(ib)%ic=itmp0(ib)
        if(itmp0(ib).eq.1) then
          allocate(bmpi(ib)%id(itmp0(ib)))
          bmpi(ib)%id(1)=kid0(ib)
        end if
      enddo

      do ib=1,nbk
        bmpi(ib)%icx=itmp1(ib)
        allocate(bmpi(ib)%idx(itmp1(ib)))
      enddo

      itmp1=0
      do id=0,np_bk-1
        if(id.eq.myid_bk) then
          isbkx=isbk0
          iebkx=iebk0
        end if
        if(myid_mx.eq.0) then
          call mpi_bcast(isbkx,1,mpi_integer,id,newcomm_bk,ierr)
          call mpi_bcast(iebkx,1,mpi_integer,id,newcomm_bk,ierr)
        end if
        call mpi_bcast(isbkx,1,mpi_integer,0,newcomm_mx,ierr)
        call mpi_bcast(iebkx,1,mpi_integer,0,newcomm_mx,ierr)
        

        itmp0=0
        do iop=ista_int,iend_int
          do ib=isbkx,iebkx
            itmp0(kop(1,iop)%jbk(ib))=1
            itmp0(kop(2,iop)%jbk(ib))=1
          enddo
        enddo

        do ib=1,isbk0-1
          if(itmp0(ib).eq.1) then
            itmp1(ib)=itmp1(ib)+1
            bmpi(ib)%idx(itmp1(ib))=id
          end if
        enddo
        do ib=isbk0,iebk0
          if(itmp0(ib).eq.1) then
            itmp1(ib)=itmp1(ib)+1
            bmpi(ib)%id(itmp1(ib))=id
            bmpi(ib)%idx(itmp1(ib))=id
          end if
        enddo
        do ib=iebk0+1,nbk
          if(itmp0(ib).eq.1) then
            itmp1(ib)=itmp1(ib)+1
            bmpi(ib)%idx(itmp1(ib))=id
          end if
        enddo
      enddo

      deallocate(itmp0,itmp1)

      return
      end
