      subroutine make_state(nx1,nx2,mhx)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: nx1,nx2,isa,isb,iea,ieb,isup,isdw,ieup,iedw,ix1,ix2,
     &           ib,ibx,nbk0,ise,it,mhx,ih
      integer(8) :: ndimspx
      integer,allocatable :: ibud(:,:),ibud0(:),iw1(:)

      ih=1

C --- INITIALIZATION
      if(allocated(bk)) deallocate(bk)

C --- SUPERBLOCK DIMENSION AND NUMBER OF SPIN-SPACE
      nbk0=0; ndimspx=0
!$OMP PARALLEL DO PRIVATE(isup,isdw,ieup,iedw) REDUCTION(+:nbk0,ndimspx)
      do ieb=1,block(2,nx2,mhx)%nbk
        do iea=1,nfrx(2)
          ieup=block(2,nx2,mhx)%nud(ieb,1)
          iedw=block(2,nx2,mhx)%nud(ieb,2)
          if(nae.gt.0) then
            ieup=ieup+iud(iea,1)
            iedw=iedw+iud(iea,2)
          end if
          do isb=block(1,nx1,mhx)%isbk,block(1,nx1,mhx)%iebk
            do isa=1,nfrx(1)
              isup=block(1,nx1,mhx)%nud(isb,1)
              isdw=block(1,nx1,mhx)%nud(isb,2)
              if(nas.gt.0) then
                isup=isup+iud(isa,1)
                isdw=isdw+iud(isa,2)
              end if

              if((isup+ieup.eq.limup.and.isdw+iedw.eq.limdw).or.
     &            id_space.eq.0) then
                nbk0=nbk0+1
                ndimspx=ndimspx
     &            +block(1,nx1,mhx)%size(isb)*block(2,nx2,mhx)%size(ieb)
              end if
            enddo
          enddo
        enddo
      enddo
      call mpi_allreduce(ndimspx,ndimsp,1,MPI_INTEGER8,mpi_sum,
     &                   newcomm_bk,ierr)
      allocate(iw1(np_bk))
      call mpi_allgather(nbk0,1,mpi_integer,iw1,1,mpi_integer,
     &                   newcomm_bk,ierr)
      nbk0=sum(iw1)
      deallocate(iw1)

      allocate(ibud0(nbk0),ibud(nbk0,5))
      nbk0=0
!!! check block number and spin
      do isb=1,block(1,nx1,mhx)%nbk
        do isa=1,nfrx(1)
          isup=block(1,nx1,mhx)%nud(isb,1)
          isdw=block(1,nx1,mhx)%nud(isb,2)
          if(nas.gt.0) then
            isup=isup+iud(isa,1)
            isdw=isdw+iud(isa,2)
          end if
          do ieb=1,block(2,nx2,mhx)%nbk
            do iea=1,nfrx(2)
              ieup=block(2,nx2,mhx)%nud(ieb,1)
              iedw=block(2,nx2,mhx)%nud(ieb,2)
              if(nae.gt.0) then
                ieup=ieup+iud(iea,1)
                iedw=iedw+iud(iea,2)
              end if

              if(isup+ieup.eq.limup.and.isdw+iedw.eq.limdw.or.
     &           id_space.eq.0) then
                nbk0=nbk0+1
                ibud(nbk0,1)=isa
                ibud(nbk0,2)=isb
                ibud(nbk0,3)=iea
                ibud(nbk0,4)=ieb
                ibud(nbk0,5)=isdw+ishft(isup,16)
                ibud0(nbk0)=ibud(nbk0,5)
              end if
            enddo
          enddo
        enddo
      enddo

      if(nbk0.gt.1) then
        do ix1=1,3
          ierr=0
          call sortii(nbk0,ibud(:,5),ibud(:,ix1),ierr)
          ibud(:,5)=ibud0(:)
        enddo
        ierr=0
        call sortii(nbk0,ibud(:,5),ibud(:,4),ierr)
      end if

      deallocate(ibud0)

      if(id_space.eq.0) then
        nbk=1
      else
        nbk=0
!$OMP PARALLEL DO REDUCTION(+:nbk)
        do ix1=2,nbk0
          if(ibud(ix1,5).ne.ibud(ix1-1,5)) then
            nbk=nbk+1
          end if
        enddo
        nbk=nbk+1
      end if

      allocate(bk(nbk,2,nh))

      if(id_space.eq.0) then
        allocate(bk(1,1,ih)%ap(nfr**nadd))
        do ix2=1,nfr**nadd
          allocate(bk(1,1,ih)%ap(ix2)%nse(2))
          bk(1,1,ih)%ap(ix2)%nse=1
        enddo

        bk(1,1,ih)%up=0
        bk(1,1,ih)%dw=0
        bk(1,2,ih)%up=0
        bk(1,2,ih)%dw=0

      else
!$OMP PARALLEL DO
        do ix1=1,nbk
          allocate(bk(ix1,1,ih)%ap(nfr**nadd))
          do ix2=1,nfr**nadd
            allocate(bk(ix1,1,ih)%ap(ix2)%nse(2))
            bk(ix1,1,ih)%ap(ix2)%nse=0
          enddo
        enddo

        nbk=1
        do ix1=2,nbk0
          bk(nbk,1,ih)%ap(ad(ibud(ix1-1,1),ibud(ix1-1,3)))%nse(1)
     &      =ibud(ix1-1,2)
          bk(nbk,1,ih)%ap(ad(ibud(ix1-1,1),ibud(ix1-1,3)))%nse(2)
     &      =ibud(ix1-1,4)
          if(ibud(ix1,5).ne.ibud(ix1-1,5)) then
            bk(nbk,1,ih)%up=ishft(ibud(ix1-1,5),-16)
            bk(nbk,1,ih)%dw=iand(ibud(ix1-1,5),2**16-1)
            bk(nbk,2,ih)%up=limup-ishft(ibud(ix1-1,5),-16)
            bk(nbk,2,ih)%dw=limdw-iand(ibud(ix1-1,5),2**16-1)
            nbk=nbk+1
          end if
        enddo
        bk(nbk,1,ih)%ap(ad(ibud(nbk0,1),ibud(nbk0,3)))%nse(1)
     &    =ibud(nbk0,2)
        bk(nbk,1,ih)%ap(ad(ibud(nbk0,1),ibud(nbk0,3)))%nse(2)
     &    =ibud(nbk0,4)
        bk(nbk,1,ih)%up=ishft(ibud(nbk0,5),-16)
        bk(nbk,1,ih)%dw=iand(ibud(nbk0,5),2**16-1)
        bk(nbk,2,ih)%up=limup-ishft(ibud(nbk0,5),-16)
        bk(nbk,2,ih)%dw=limdw-iand(ibud(nbk0,5),2**16-1)
      end if

      deallocate(ibud)

!$OMP PARALLEL DO
      do ib=1,nbk
        allocate(bk(ib,1,ih)%sizex(nfrx(1)),
     &           bk(ib,2,ih)%sizex(nfrx(2)),
     &           bk(ib,1,ih)%stax(nfrx(1)),
     &           bk(ib,1,ih)%endx(nfrx(1)),
     &           bk(ib,2,ih)%stax(nfrx(2)),
     &           bk(ib,2,ih)%endx(nfrx(2)),
     &           bk(ib,1,ih)%ibs(-1:1,nop),
     &           bk(ib,2,ih)%ibs(-1:1,nop))

        bk(ib,1,ih)%size=0   !SYSTEM
        bk(ib,1,ih)%sizex=0
        do isa=1,nfrx(1)
          do iea=1,nfrx(2)
            if(bk(ib,1,ih)%ap(ad(isa,iea))%nse(1).ne.0) then
              bk(ib,1,ih)%size=bk(ib,1,ih)%size
     &        +block(1,nx1,mhx)%size(bk(ib,1,ih)%ap(ad(isa,iea))%nse(1))
              bk(ib,1,ih)%sizex(isa)
     &        =block(1,nx1,mhx)%size(bk(ib,1,ih)%ap(ad(isa,iea))%nse(1))
              exit
            end if
          enddo
        enddo

c        write(6,*) mhx

        bk(ib,2,ih)%size=0   !ENVIRONMENT
        bk(ib,2,ih)%sizex=0
        do iea=1,nfrx(2)
          do isa=1,nfrx(1)
            if(bk(ib,1,ih)%ap(ad(isa,iea))%nse(2).ne.0) then
              bk(ib,2,ih)%size=bk(ib,2,ih)%size
     &        +block(2,nx2,mhx)%size(bk(ib,1,ih)%ap(ad(isa,iea))%nse(2))
              bk(ib,2,ih)%sizex(iea)
     &        =block(2,nx2,mhx)%size(bk(ib,1,ih)%ap(ad(isa,iea))%nse(2))
              exit
            end if
          enddo
        enddo

        do ise=1,2
          bk(ib,ise,ih)%stax(1)=1
          do isa=1,nfrx(ise)-1
            bk(ib,ise,ih)%endx(isa)
     &        =bk(ib,ise,ih)%stax(isa)+bk(ib,ise,ih)%sizex(isa)-1
            bk(ib,ise,ih)%stax(isa+1)=bk(ib,ise,ih)%endx(isa)+1
          enddo
          bk(ib,ise,ih)%endx(nfrx(ise))
     &      =bk(ib,ise,ih)%stax(nfrx(ise))
     &        +bk(ib,ise,ih)%sizex(nfrx(ise))-1
        enddo

        if(id_space.eq.0) then
          bk(ib,1,ih)%ibs=1
          bk(ib,2,ih)%ibs=1
        else
          bk(ib,1,ih)%ibs=0
          bk(ib,2,ih)%ibs=0
          do it=1,nop
            bk(ib,1,ih)%ibs(0,it)=ib
            bk(ib,2,ih)%ibs(0,it)=ib
          enddo

          do ibx=1,nbk
            do it=1,nop
              if(bk(ib,1,ih)%up-nch(1,it).eq.bk(ibx,1,ih)%up.and.
     &           bk(ib,1,ih)%dw-nch(2,it).eq.bk(ibx,1,ih)%dw) then
                bk(ib,1,ih)%ibs(1,it)=ibx
                bk(ib,2,ih)%ibs(-1,it)=ibx
              end if
              if(bk(ib,1,ih)%up+nch(1,it).eq.bk(ibx,1,ih)%up.and.
     &           bk(ib,1,ih)%dw+nch(2,it).eq.bk(ibx,1,ih)%dw) then
                bk(ib,1,ih)%ibs(-1,it)=ibx
                bk(ib,2,ih)%ibs(1,it)=ibx
              end if
            enddo
          enddo
        end if
      enddo

      return
      end
