      subroutine matrix_vec(id,v0,v1,cf)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: id,iop,ib,ih
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) ::
#endif
     &  cf,cp,cc
#ifdef dep
      integer,parameter :: id_dep=1
#endif
      type(avec) :: v0(isbk0:iebk0),v1(isbk0:iebk0)
      type(avec),allocatable :: vin(:)

      ih=1

      allocate(vx(nbk),nv(nfrx(1),nfrx(2),nbk))
      do ib=1,nbk
        allocate(vx(ib)%ap(ad(nfrx(1),nfrx(2))))
      enddo
      nv=0

      cp=cf*ps
#ifdef cmplx_v
      cc=conjg(cp)
#else
      cc=cp
#endif

#ifdef dep
      if(id_dep.eq.1) call mpi_barrier(newcomm_dmrg,ierr)
      time_test(1)=mpi_wtime()
#endif
      allocate(vin(isbk0:iebk0))
      call mpi_vec(v0,vin)
#ifdef dep
      time_test(8)=time_test(8)+mpi_wtime()-time_test(1)
      if(id_dep.eq.1) call mpi_barrier(newcomm_dmrg,ierr)
      time_test(2)=mpi_wtime()
#endif

! --- MATRIX x MATRIX
      do iop=ista_int,iend_int
        if(isbk0.gt.iebk0) exit
        select case(th(id)%kh(iop))
          case(0)
            call mv_init(v1,vx,isbk0,iebk0)
            call mv_sint(0,vin,vx,kop(:,iop),pop(1,iop),cf)
            call mv_eint(0,v0,vx,kop(:,iop),pop(2,iop),cf)
            call mv_apt(vin,vx,cf)
          case(1,3)
            call mv_sint(th(id)%ic(iop),vin,vx,kop(:,iop),pop(:,iop),
     &                   cp)
          case(2,4)
           call mv_eint(th(id)%ic(iop),v0,vx,kop(:,iop),pop(:,iop),
     &                   cp)
          case(5)
            if(th(id)%ic(iop).eq.0) then
              call mv_4(th(id)%ic(iop),vin,vx,kop(:,iop),pop(:,iop),cf)
            else
              call mv_4(th(id)%ic(iop),vin,vx,kop(:,iop),pop(:,iop),cc)
            end if
          case(6)
            call mv_aint(th(id)%ic(iop),vin,vx,kop(:,iop),cp)
          case(7:8)
            call mv_aint(th(id)%ic(iop),vin,vx,kop(:,iop),cf)
        end select
      enddo
      deallocate(vin)


#ifdef dep
      time_test(9)=time_test(9)+mpi_wtime()-time_test(2)
      if(id_dep.eq.1) call mpi_barrier(newcomm_dmrg,ierr)
      time_test(3)=mpi_wtime()
#endif
      call mpi_bk(vx,bmpi)
#ifdef dep
      time_test(10)=time_test(10)+mpi_wtime()-time_test(3)
      if(id_dep.eq.1) call mpi_barrier(newcomm_dmrg,ierr)
      time_test(4)=mpi_wtime()
#endif
!!!      call mpi_add(vx)
      deallocate(nv)
#ifdef dep
      time_test(11)=time_test(11)+mpi_wtime()-time_test(4)
      if(id_dep.eq.1) call mpi_barrier(newcomm_dmrg,ierr)
      time_test(5)=mpi_wtime()
#endif
      call mpi_mxint(vx,v1)
#ifdef dep
      time_test(12)=time_test(12)+mpi_wtime()-time_test(5)
      if(id_dep.eq.1) call mpi_barrier(newcomm_dmrg,ierr)
      time_test(6)=mpi_wtime()
#endif

#ifdef dep
      time_test(7)=mpi_wtime()
      time_test(13)=time_test(13)+time_test(7)-time_test(6)
#endif
      deallocate(vx)

      return
      end
