      subroutine output()
      use mod_dmrg
#ifdef EigenExa
      use eigen_libs
#endif
      implicit none
      include 'mpif.h'
      integer :: ic

      if(myid_dmrg.eq.key_rank) then
        write(iso,*)
        write(iso,'(1x,a)')
     &  '#     <  m  >     <   energy   >   <    E.E.   >   <  error  >'
        do ic=0,icphys
          write(iso,'(I5,1x,I7,1x,f19.12,1x,f15.11,2x,1Pe12.5)') 
     &      ic,phys(1)%isw(ic),phys(2)%dsw(ic),
     &      phys(3)%dsw(ic),phys(4)%dsw(ic)
        enddo

#ifdef timer
        write(iso,*)
        write(iso,'(1x,a)') '# statistics of elapsed time:'
        write(iso,'(2x,a,f16.3,a,f6.2,a)')
     &    '(initialization): ',times(1),' [s] (',
     &    times(1)/times(5)*1.d2,'%)'
        write(iso,'(2x,a,f19.3,a,f6.2,a)')
     &    '(Hamiltonian): ',times(2),' [s] (',
     &    times(2)/times(5)*1.d2,'%)'
        write(iso,'(2x,a,f18.3,a,f6.2,a)')
     &    '(target state): ',times(3),' [s] (',
     &    times(3)/times(5)*1.d2,'%)'
        write(iso,'(2x,a,f16.3,a,f6.2,a)')
     &    '(density matrix): ',times(4),' [s] (',
     &    times(4)/times(5)*1.d2,'%)'
        write(iso,'(2x,a,f25.3,a,f6.2,a)')
     &    '(total): ',times(5),' [s] (',
     &    times(5)/times(5)*1.d2,'%)'
#endif
        if(iso.gt.6) close(iso)
      end if

#ifdef timer
      deallocate(time,times)
#endif

c --- FINALIZE
      call mpi_comm_free(newcomm_int,ierr)
      call mpi_comm_free(newcomm_tm,ierr)
      call mpi_comm_free(newcomm_add,ierr)
      call mpi_comm_free(newcomm_bk,ierr)
      call mpi_comm_free(newcomm_mx,ierr)
      deallocate(block,iud,nch,nse,ndmx,hamil,phys,ht,iht,ihm,
     &           kch,kud,fsi,name_op,iad,idest_add,np_ma,icth4,idsh4,
     &           ihcf,nfrx,cmag)
      if(allocated(op)) deallocate(op)
#ifdef cmplx_v
      if(allocated(opz)) deallocate(opz)
#endif
      if(allocated(ddmrg)) deallocate(ddmrg)
      if(allocated(tdmrg)) deallocate(tdmrg)
      if(allocated(hamil0)) deallocate(hamil0)
      if(allocated(fmag)) deallocate(fmag)
      if(myid_dmrg.eq.0) close(99)

#ifdef sclpk
      call eigen_free_sclpk() !finalize Scalapack
#endif

#ifdef EigenExa
      call eigen_free()
#endif

      return
      end
