      subroutine pcal_main(para)
      implicit real(8)(a-h,o-y),complex(8)(z)
      include 'mpif.h'
      character(*) para

      write(6,*) 'test',para

      res=0.d0
      call pcal(para,res)
      write(para,*) res

      write(6,*) 'test',res

      return
      end

***********************************************************************
      recursive subroutine pcal(para,res)
      implicit real(8)(a-h,o-y),complex(8)(z)
      include 'mpif.h'
      dimension kop(0:1)
      character(*) para
      integer,allocatable :: icxa(:)

      allocate(icxa(4))
      icxa(1)=index(para(1:),'+')
      icxa(2)=index(para(1:),'-')
      icxa(3)=index(para(1:),'*')
      icxa(4)=index(para(1:),'/')
      if(icxa(2).ne.0.and.icxa(1)+icxa(3)+icxa(4).eq.0) then
        read(para,*) res
        deallocate(icxa)
        return
      end if
      deallocate(icxa)

c--- initialize 
      res=0.d0
      icx=1
      nx=0
      i0=1

      do while(icx.ne.0)
        nx=nx+1
        mx=mod(nx,2)
        icx=0; kop(mx)=0
c--- check operators and constants
        do lx=1,4
          if(lx.eq.1) icx0=index(para(i0:),'+')
          if(lx.eq.2) icx0=index(para(i0:),'-')
          if(lx.eq.3) icx0=index(para(i0:),'*')
          if(lx.eq.4) icx0=index(para(i0:),'/')
          if((icx.eq.0.and.icx0.ne.0).or.
     &        (icx0.lt.icx.and.icx0.ne.0)) then
            icx=icx0
            kop(mx)=lx
          end if
        enddo

c--- calculation
        if(icx.eq.1) then
          i0=icx+1
          cycle
        elseif(nx.eq.1) then
          if(icx.eq.0) then
            call pcal_sub(0,para(i0:),res)
          else
            call pcal_sub(0,para(i0:(icx-1)),res)
            i0=icx+1
          end if
        else
          if(icx.eq.0) then
            call pcal_sub(kop(mod(nx-1,2)),para(i0:),res)
          else
            icx=icx+i0-1
            call pcal_sub(kop(mod(nx-1,2)),para(i0:(icx-1)),res)
            i0=icx+1
          end if
        end if
      enddo

      return
      end

***********************************************************************
      recursive subroutine pcal_sub(id,para,res)
      implicit real(8)(a-h,o-y),complex(8)(z)
      character(*) para
      character(64) para64

      write(para64,*) para

      call pcal_sub01(para64,res0)
      if(id.eq.0) then
        res=res0
      elseif(id.eq.1) then !'+'
        res=res+res0
      elseif(id.eq.2) then !'-'
        res=res-res0
      elseif(id.eq.3) then !'*'
        res=res*res0
      elseif(id.eq.4) then !'/'
        res=res/res0
      end if

      return
      end

***********************************************************************
      recursive subroutine pcal_sub01(para,res)
      implicit real(8)(a-h,o-y),complex(8)(z)
      character(*) para

      i1=index(para,'(')
      if(i1.ne.0) then
        ix1=index(para,'sqrt')
        ix2=index(para,'sin')
        ix3=index(para,'cos')
        ix4=index(para,'tan')
        ix5=index(para,'exp')
        i2=index(para(i1+1:),')')+i1
        call pcal(para(i1+1:i2-1),res)
      else
        ix1=0
        ix2=0
        ix3=0
        ix4=0
        ix5=0
      end if

      icpi=index(para,'pi')
      if(icpi.ne.0) then
        res=4.d0*atan(1.d0)
      elseif(ix1.ne.0) then
        res=sqrt(res)
      elseif(ix2.ne.0) then
        res=sin(res)
      elseif(ix3.ne.0) then
        res=cos(res)
      elseif(ix4.ne.0) then
        res=tan(res)
      elseif(ix5.ne.0) then
        res=exp(res)
      else
        read(para,*) res
      end if

      return
      end
