      subroutine phys_main(iv)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer,parameter :: icl=10
      integer :: iv,mp,ios,i0,i1,ix1,ix2,ix3,ip,mmx,ifl,iop,iout
      integer,allocatable :: ica(:),nss(:,:)
      character(256) :: para,fname_p,fname_o
      type(inop),allocatable :: tp(:)

      ios=0; i1=0; ifl=0; iout=0
      if(myid_dmrg.eq.key_rank) then
        open(10,file=file_phys,status='old',err=100)
        ios=1
  100   continue
      end if
      call mpi_bcast(ios,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      if(ios.eq.0) goto 1000

      ios=0; ip=0
      do while(ios.ge.0)
        if(myid_dmrg.eq.key_rank) then
          read(10,'(a)',iostat=ios) para
        end if
        call mpi_bcast(ios,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
        if(ios.lt.0) exit

        call mpi_bcast(para,256,mpi_character,key_rank,newcomm_dmrg,
     &                 ierr)

! ----- COMENT 1
        i0=index(para,'#')
        if(i0.ne.0) then
          if(myid_dmrg.eq.key_rank) then
            write(iso,'(1x,a)') TRIM(para)
          end if
          cycle
        end if

! ----- COMENT 2
        i0=index(para,'!')
        if(i0.ne.0) cycle

! ----- BLANK LINE
        i0=LEN_TRIM(para)
        if(i0.eq.0) cycle

! ----- OPERATORS
        if(myid_dmrg.eq.key_rank) then
          i0=index(para,'<')
        end if
        call mpi_bcast(i0,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
        if(i0.ne.0) then
          if(ip.gt.0) then
            call phys_ipara(iv,ip,tp,mp,nss,sum(tp(1:mp)%mi),iout)
          end if
          ip=0
          ifl=ifl+1
          if(myid_dmrg.eq.key_rank) then
            write(iso,'(1x,a)',advance='no') '#'
            mp=0
            do while(i0.ne.0)
              mp=mp+1
              i1=i0+index(para(i0+1:),'>')
              if(index(para(i1+1:),'<').eq.0) exit
              i0=i1+index(para(i1+1:),'<')
            enddo

            if(id_tdmrg.eq.1) then
              close(50,err=990)
  990         call system('mkdir -p OUTPUT')
c              write(fname_p,'(a,I0,a,I0,a)') 
c     &          'OUTPUT/',ifl,'_',isweep,'.dat'
              if(if_tdmrg.eq.1) then
                write(fname_p,'(a,I0,a,I0,a,I0,a)') 
     &            'OUTPUT/',ifl,'_',isweep,'_',iv-id_multi,'.dat'
              else
                write(fname_p,'(a,I0,a,I0,a,I0,a)') 
     &            'OUTPUT/',ifl,'_',isweep,'_',iv,'.dat'
              end if
              open(unit=50,file=fname_p)
            end if

            if(idmrg.eq.ndmrg) then
              if(iout.eq.1) close(51)
              write(fname_o,'(a,I0,a)') TRIM(file_phys_op),ifl,'.dat'
              open(51,file=fname_o)
              iout=1
            end if
          end if
          call mpi_bcast(mp,1,mpi_integer,key_rank,newcomm_dmrg,ierr)

          if(allocated(tp)) deallocate(tp)
          allocate(tp(mp+1))

          tp(1)%fi=1
          if(myid_dmrg.eq.key_rank) then
            i0=index(para,'<')
            i1=i0+index(para(i0+1:),'>')
          end if
          do ix1=1,mp
            allocate(ica(icl))
            ica=999
            if(myid_dmrg.eq.key_rank) then
              read(para(i0+1:i1-1),*,iostat=ix2) ica(:)
            end if
            call mpi_bcast(ica,icl,mpi_integer,key_rank,newcomm_dmrg,
     &                     ierr)

            tp(ix1)%mi=0
            do ix2=1,icl
              if(ica(ix2).eq.999) exit
              tp(ix1)%mi=tp(ix1)%mi+1
            enddo
            allocate(tp(ix1)%ni(tp(ix1)%mi),tp(ix1)%ki(tp(ix1)%mi))
            do ix2=1,tp(ix1)%mi
              tp(ix1)%ki(ix2)=ica(ix2)
            enddo
            deallocate(ica)

            if(myid_dmrg.eq.key_rank) then
              if(allocated(name_op)) then
                write(iso,'(1x,a)',advance='no') '<'
                do ix2=1,tp(ix1)%mi
                  write(iso,'(1x,a)',advance='no') 
     &              TRIM(name_op(tp(ix1)%ki(ix2)))
                enddo
                write(iso,'(1x,a)',advance='no') '>'
              else
                write(iso,'(1x,a)',advance='no') '<'
                do ix2=1,tp(ix1)%mi
                  write(iso,'(1x,I0)',advance='no') tp(ix1)%ki(ix2)
                enddo
                write(iso,'(1x,a)',advance='no') '>'
              end if

              i0=i1+index(para(i1+1:),'<')
              if(i0.ne.i1) then
                ix2=index(para(i1+1:i0-1),'+')
                if(index(para(i1+1:i0-1),'+').ne.0) then
                  write(iso,'(1x,a)',advance='no') '+'
                  tp(ix1+1)%fi=1
                elseif(index(para(i1+1:i0-1),'-').ne.0) then
                  write(iso,'(1x,a)',advance='no') '-'
                  tp(ix1+1)%fi=2
                elseif(index(para(i1+1:i0-1),'/').ne.0) then
                  write(iso,'(1x,a)',advance='no') '/'
                  tp(ix1+1)%fi=3
                else
                  write(iso,'(1x,a)',advance='no') '*'
                  tp(ix1+1)%fi=4
                end if
              else
                write(iso,*)
              end if
              i1=i0+index(para(i0+1:),'>')
            end if
            call mpi_bcast(tp(ix1+1)%fi,1,mpi_integer,key_rank,
     &                     newcomm_dmrg,ierr)
          enddo
          if(allocated(nss)) deallocate(nss)
          allocate(nss(sum(tp(1:mp)%mi),np_int))
          cycle
        end if

C --- EXPECTATION VALUES
C ----- EACH SITES
        if(index(para,'E').ne.0) then
          mmx=sum(tp(1:mp)%mi)
          do ix1=1,nsite/np_int+1
            ip=min(np_int,nsite-(ix1-1)*np_int)
            do ix2=1,ip
              nss(1:mmx,ix2)=ix2+np_int*(ix1-1)
            enddo
            call phys_ipara(iv,ip,tp,mp,nss,mmx,iout)
          enddo
          ip=0
          cycle
        end if

C ----- ALL PAIR
        if(index(para,'P').ne.0) then
          mmx=sum(tp(1:mp)%mi)
          do ix1=1,(nsite*nsite)/np_int+1
            ip=min(np_int,(nsite*nsite)-(ix1-1)*np_int)
            do ix2=1,ip
              do ix3=1,mp
                nss(1+2*(ix3-1),ix2)=mod(ix2+np_int*(ix1-1)-1,nsite)+1
                nss(2+2*(ix3-1),ix2)=(ix2+np_int*(ix1-1)-1)/nsite+1
              enddo
            enddo
            call phys_ipara(iv,ip,tp,mp,nss,mmx,iout)
          enddo
          ip=0
          cycle
        end if

C ----- BOND (2-BODY TERMS)
        if(index(para,'B').ne.0) then
          mmx=sum(tp(1:mp)%mi)
          do ix1=1,nh2/np_int+1
            ip=min(np_int,nh2-(ix1-1)*np_int)
            do ix2=1,ip
              do ix3=1,mp
                iop=ix2+np_int*(ix1-1)
                nss(1+2*(ix3-1),ix2)=hamil(iop)%ihs(1)
                nss(2+2*(ix3-1),ix2)=hamil(iop)%ihs(2)
              enddo
            enddo
            call phys_ipara(iv,ip,tp,mp,nss,mmx,iout)
          enddo
          ip=0
          cycle
        end if 

C ----- NOMAL
        ip=ip+1
        read(para,*) nss(:,ip)
        if(ip.eq.np_int) then
          call phys_ipara(iv,ip,tp,mp,nss,sum(tp(1:mp)%mi),iout)
        end if

      enddo

      if(ip.gt.0) then
        call phys_ipara(iv,ip,tp,mp,nss,sum(tp(1:mp)%mi),iout)
      end if
      if(allocated(nss)) deallocate(nss)
      if(myid_dmrg.eq.key_rank) then
        close(10)
        if(id_tdmrg.eq.1) close(50)
        if(iout.eq.1) close(51)
      end if

 1000 continue

      return
      end
