      subroutine qphys_main(iv1)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iv1,ib,ix,ios,i0,i1,ips,iout,nq,nps
      integer(8) :: imem
      real(8) :: ft,ft0,x0
      integer,allocatable :: ns(:),isp(:),is(:,:)
      real(8),allocatable :: rx(:),ry(:),qx(:),qy(:),res(:),res0(:)
      type(avec),allocatable :: v0(:),va(:,:)
      character(64) para,fname_o

      nq=0; nps=0; iout=0
      allocate(rx(nsite),ry(nsite),isp(nsite))
      if(myid_dmrg.eq.key_rank) then
        ios=-2
        open(10,file=file_qphys,status='old',err=998)
        ios=0
        do while(ios.ge.0)
          read(10,'(a)',iostat=ios) para
          if(ios.lt.0) exit
          if(index(para,'!').ne.0) cycle
          if(index(para,'boundary condition').ne.0) cycle
          if(index(para,'<').ne.0) then
            nps=nps+1
            cycle
          end if
          nq=nq+1
        enddo
        close(10)
      end if
  998 continue

      call mpi_bcast(ios,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      if(ios.eq.-2) goto 999
      call mpi_bcast(nq,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(nps,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      allocate(qx(nq),qy(nq),res(nq),is(2,nps))

      if(myid_dmrg.eq.key_rank) then
        nq=0; nps=0
        open(10,file=file_qphys,status='old')
        ios=0
        do while(ios.ge.0)
          read(10,'(a)',iostat=ios) para
          if(ios.lt.0) exit
          if(index(para,'!').ne.0) cycle
          if(index(para,'boundary condition').ne.0) then
            i0=index(para,':')+1
            read(para(i0:),*) boundary
            cycle
          end if
          if(index(para,'<').ne.0) then
            nps=nps+1
            i0=index(para,'<')
            i1=index(para,'>')
            read(para(i0+1:i1-1),*) is(:,nps)
            cycle
          end if
          nq=nq+1
          if(index(para,',').ne.0) then
            i1=index(para,',')
            i0=index(para,'(')
            call pcal(para(i0+1:i1-1),qx(nq))
            i0=index(para,')')
            if(i0.eq.0) then
              call pcal(para(i1+1:),qy(nq))
            else
              call pcal(para(i1+1:i0-1),qy(nq))
            end if
            cycle
          end if
          read(para,*) qx(nq),qy(nq)
        enddo
        close(10)

        open(10,file=file_posit,status='old')
        do ix=1,nsite
          read(10,*) isp(ix),rx(ix),ry(ix)
        enddo
        close(10)
      end if
      call mpi_bcast(is,2*nps,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(qx,nq,MPI_REAL8,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(qy,nq,MPI_REAL8,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(isp,nsite,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(rx,nsite,MPI_REAL8,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(ry,nsite,MPI_REAL8,key_rank,newcomm_dmrg,ierr)

! --- INITIALIZE VECTORS
      do ips=1,nps
        if(myid_dmrg.eq.key_rank) then
          write(iso,'(1x,a)',advance='no')
     &       '#   < qx >     < qy >     '
          if(allocated(name_op)) then
            write(iso,'(1x,a)',advance='no') '<'
            do ix=1,2
              write(iso,'(1x,a)',advance='no')
     &          TRIM(name_op(is(ix,ips)))
            enddo
            write(iso,'(1x,a)') '>'
          else
            write(iso,'(1x,a)',advance='no') '<'
            do ix=1,2
              write(iso,'(1x,I0)',advance='no') is(ix,ips)
            enddo
            write(iso,'(1x,a)') '>'
          end if
          if(idmrg.eq.ndmrg) then
            if(iout.ne.0) close(51)
            write(fname_o,'(a,I0,a)') TRIM(file_qphys_op),iout+1,'.dat'
            open(51,file=fname_o)
            iout=iout+1
          end if
        end if

        if(is(1,ips).eq.is(2,ips).and.1==0) then !Hermitian case
          allocate(va(isbk0:iebk0,1+4*nq))
          call init_vtmp(v(isbk1:iebk1,iv1),va(isbk0:iebk0,1))
          do ix=2,2*nq+1
            call lz_acv(va(isbk0:iebk0,ix),isbk0,iebk0,1,imem)
          enddo
          do ix=2*nq+2,4*nq+1
            call lz_acv(va(isbk1:iebk1,ix),isbk1,iebk1,1,imem)
          enddo

          allocate(ns(1))
          do ix=myid_int+1,nsite,np_int
            if(isp(ix).eq.0) cycle

            allocate(v0(nbk))
            do ib=1,nbk; allocate(v0(ib)%ap(ad(nfrx(1),nfrx(2)))); enddo
            call vclr(v0(isbk0:iebk0),isbk0,iebk0,zero)

            ns(1)=ix
            call phys_v(va(:,1),1,ns,is(2,ips),v0)

            do i0=1,nq
              call ft_coeff('cos_'//boundary,rx(ix),ry(ix),
     &                      qx(i0),qy(i0),ft)
              if(abs(ft).gt.1.d-16) then
                call adv(ft,v0(isbk0:iebk0),va(:,i0+1),isbk0,iebk0)
              end if

              call ft_coeff('sin_'//boundary,rx(ix),ry(ix),
     &                      qx(i0),qy(i0),ft)
              if(abs(ft).gt.1.d-16) then
                call adv(ft,v0(isbk0:iebk0),va(:,i0+nq+1),isbk0,iebk0)
              end if
            enddo
            deallocate(v0)
          enddo

! --- SET OPERATED VECTORS
          do ix=1,nq
            call set_vec(va(isbk0:iebk0,ix+1),va(isbk1:iebk1,ix+2*nq+1))
            call set_vec(va(isbk0:iebk0,ix+nq+1),
     &                   va(isbk1:iebk1,ix+3*nq+1))
          enddo

          do ix=1,nq
            call ipv(va(isbk1:iebk1,ix+2*nq+1),
     &               va(isbk1:iebk1,ix+2*nq+1),
     &               isbk1,iebk1,x0)
            res(ix)=x0
            call ipv(va(isbk1:iebk1,ix+3*nq+1),
     &               va(isbk1:iebk1,ix+3*nq+1),
     &               isbk1,iebk1,x0)
            res(ix)=res(ix)+x0
          enddo

        else !not Hermitian case
          allocate(va(isbk0:iebk0,1))
          call init_vtmp(v(isbk1:iebk1,iv1),va(isbk0:iebk0,1))

          allocate(ns(2),res0(nq))
!$OMP PARALLEL WORKSHARE
          res0=0.d0
!$OMP END PARALLEL WORKSHARE
          do ix=myid_int+1,nsite*nsite,np_int
            ns(1)=(ix-1)/nsite+1
            ns(2)=mod(ix-1,nsite)+1
            if(isp(ns(1)).eq.0.or.isp(ns(2)).eq.0) cycle

            allocate(v0(nbk))
            do ib=1,nbk; allocate(v0(ib)%ap(ad(nfrx(1),nfrx(2)))); enddo
            call vclr(v0(isbk0:iebk0),isbk0,iebk0,zero)

            call phys_v(va(:,1),2,ns,is(:,ips),v0)
            call phys_i(va(:,1),x0,v0)

            do i0=1,nq
              call ft_coeff('cos_'//boundary,rx(ns(1)),
     &                      ry(ns(1)),qx(i0),qy(i0),ft)
              call ft_coeff('cos_'//boundary,rx(ns(2)),
     &                      ry(ns(2)),qx(i0),qy(i0),ft0)
              ft=ft*ft0
              res0(i0)=res0(i0)+ft*x0

              call ft_coeff('sin_'//boundary,rx(ns(1)),
     &                      ry(ns(1)),qx(i0),qy(i0),ft)
              call ft_coeff('sin_'//boundary,rx(ns(2)),
     &                      ry(ns(2)),qx(i0),qy(i0),ft0)
              ft=ft*ft0
              res0(i0)=res0(i0)+ft*x0
            enddo
            deallocate(v0)
          enddo

          call mpi_allreduce(res0,res,nq,MPI_REAL8,
     &                       mpi_sum,newcomm_int,ierr)
          deallocate(res0)
        end if
        if(myid_dmrg.eq.key_rank) then
          do i0=1,nq
            write(iso,'(1x,f10.4,1x,f10.4,3x,e14.6)')
     &        qx(i0),qy(i0),res(i0)
          enddo
          if(iout.ne.0) then
            do i0=1,nq
              write(51,'(1x,f10.4,1x,f10.4,3x,e14.6)')
     &          qx(i0),qy(i0),res(i0)
            enddo
          end if
        end if
        deallocate(ns,va)
      enddo

      deallocate(isp,rx,ry,qx,qy)

      if(iout.ne.0) close(51)

  999 continue

      return
      end
