      subroutine random_UV(id,i)
      use mod_dmrg_input
      implicit none
      include 'mpif.h'
      integer :: id,i,i1,ios,ierr
      real(8) :: U,V,R(np_dmrg_r)
      character(64) :: para,file_preset,file_log

      if(myid_dmrg.eq.0) then
        if(np_dmrg_r.eq.1) then
          write(file_preset,'(a)') 'preset.txt'
          write(file_log,'(a)') 'UV_log.dat'
        elseif(np_dmrg_r.gt.1) then
          write(file_preset,'(a,I0,a)') 'preset',myid_dmrg_r,'.txt'
          write(file_log,'(a,I0,a)') 'UV_log',myid_dmrg_r,'.dat'
        end if

        open(7,file='preset.txt')
        open(8,file=file_preset)
        open(9,file=file_log,position='append')
        ios=0
        do while(ios.ge.0)
          read(7,'(a)',iostat=ios) para
          if(ios.lt.0) exit
          if(index(para,'#').ne.0) cycle
          write(8,'(a)') para
        enddo

        if(id.eq.0) then
          if(myid_dmrg_r.eq.0) call random_number(R)
          call mpi_bcast(R,np_dmrg_r,MPI_REAL8,0,newcomm_dmrg_r,ierr)
          U=10.d0*R(myid_dmrg_r+1)
          if(myid_dmrg_r.eq.0) call random_number(R)
          call mpi_bcast(R,np_dmrg_r,MPI_REAL8,0,newcomm_dmrg_r,ierr)
          V=5.d0*R(myid_dmrg_r+1)
        elseif(id.eq.1) then
          i1=np_dmrg_r*(i-1)+myid_dmrg_r+1
          U=dble(mod(i1-1,11))*1.d-0
          V=dble((i1-1)/11)*1.d-0
        elseif(id.eq.2) then
          if(myid_dmrg_r.eq.0) call random_number(R)
          call mpi_bcast(R,np_dmrg_r,MPI_REAL8,0,newcomm_dmrg_r,ierr)
          if(R(myid_dmrg_r+1).le.0.5d0) then
            if(myid_dmrg_r.eq.0) call random_number(R)
            call mpi_bcast(R,np_dmrg_r,MPI_REAL8,0,newcomm_dmrg_r,ierr)
            U=R(myid_dmrg_r+1)
            if(myid_dmrg_r.eq.0) call random_number(R)
            call mpi_bcast(R,np_dmrg_r,MPI_REAL8,0,newcomm_dmrg_r,ierr)
            V=R(myid_dmrg_r+1)+5.d0
          else
            if(myid_dmrg_r.eq.0) call random_number(R)
            call mpi_bcast(R,np_dmrg_r,MPI_REAL8,0,newcomm_dmrg_r,ierr)
            U=R(myid_dmrg_r+1)+10.d0
            if(myid_dmrg_r.eq.0) call random_number(R)
            call mpi_bcast(R,np_dmrg_r,MPI_REAL8,0,newcomm_dmrg_r,ierr)
            V=R(myid_dmrg_r+1)
          end if
        elseif(id.eq.3) then
          i1=np_dmrg_r*(i-1)+myid_dmrg_r+1
          U=10.d0
          V=dble(i1-1)*1.d-1
        elseif(id.eq.4) then
          U=10.d0
          if(myid_dmrg_r.eq.0) call random_number(R)
          call mpi_bcast(R,np_dmrg_r,MPI_REAL8,0,newcomm_dmrg_r,ierr)
          V=10.d0*R(myid_dmrg_r+1)
        elseif(id.eq.5) then
          if(myid_dmrg_r.eq.0) call random_number(R)
          call mpi_bcast(R,np_dmrg_r,MPI_REAL8,0,newcomm_dmrg_r,ierr)
          if(R(myid_dmrg_r+1).le.1.d0/3.d0) then
            if(myid_dmrg_r.eq.0) call random_number(R)
            call mpi_bcast(R,np_dmrg_r,MPI_REAL8,0,newcomm_dmrg_r,ierr)
            U=2.d0*R(myid_dmrg_r+1)+6.d0
            if(myid_dmrg_r.eq.0) call random_number(R)
            call mpi_bcast(R,np_dmrg_r,MPI_REAL8,0,newcomm_dmrg_r,ierr)
            V=2.d0*R(myid_dmrg_r+1)
            ML_label(1)=0
          elseif(R(myid_dmrg_r+1).le.2.d0/3.d0) then
            if(myid_dmrg_r.eq.0) call random_number(R)
            call mpi_bcast(R,np_dmrg_r,MPI_REAL8,0,newcomm_dmrg_r,ierr)
            U=2.d0*R(myid_dmrg_r+1)
            if(myid_dmrg_r.eq.0) call random_number(R)
            call mpi_bcast(R,np_dmrg_r,MPI_REAL8,0,newcomm_dmrg_r,ierr)
            V=2.d0*R(myid_dmrg_r+1)+3.d0
            ML_label(1)=1
          else
            if(myid_dmrg_r.eq.0) call random_number(R)
            call mpi_bcast(R,np_dmrg_r,MPI_REAL8,0,newcomm_dmrg_r,ierr)
            U=2.d0*R(myid_dmrg_r+1)+2.d0
            if(myid_dmrg_r.eq.0) call random_number(R)
            call mpi_bcast(R,np_dmrg_r,MPI_REAL8,0,newcomm_dmrg_r,ierr)
            V=0.5d0*U
            ML_label(1)=2
          end if
        end if

        if(id.le.4) then
          if(V*2.d0.gt.U) then
            ML_label(1)=1
          else
            ML_label(1)=0
          end if
        end if

        write(8,'(a,f10.6)') '# U=',U
        write(8,'(a,f10.6)') '# V=',V
        write(9,'(f10.6,1x,f10.6,1x,I0)') U,V,ML_label(1)

        close(7)
        close(8)
        close(9)
      end if

      return
      end
