      subroutine read_parameters()
      use mod_dmrg
!$    use omp_lib
      implicit none
      include 'mpif.h'
      integer :: ios
      character(64) para

! --- READING PARAMETERS FILE
      if(myid_dmrg.eq.0) then
        ios=-1
        open(10,file=file_param,status='old',err=991)
        ios=0
  991   if(ios.ne.0) then
          open(10,file='parameters.txt',status='old',err=999)
          ios=0
        end if
        do while(ios.ge.0)
          read(10,'(a)',iostat=ios) para
          if(ios.lt.0) exit
          write(iso,'(1x,a)') para
          call trace_parameters(para)
        enddo
        close(10)
      end if

! --- BLOAD CAST PARAMETERS
      call mpi_bcast(mts,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(nsweep_g,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(indw,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(inup,1,mpi_integer,key_rank,newcomm_dmrg,ierr)

! --- FIX PARAMETERS FOR SYSTEM
      if(id_spinless.eq.1) then
        inup=inup+indw
        indw=0
      end if

! --- INPUT OF tDMRG
#ifdef cmplx_v
      call read_scenario()
#endif

! --- NUMBER OF TOTAL SWEEP
      if(id_tdmrg.ne.0) then
        nsweep=nsweep_g+nsweep_t
      else
        nsweep=nsweep_g
        ns_ech=1
      end if

! --- OUTPUT PARALLEL INFOMATIONS
      if(myid_dmrg.eq.key_rank) then
        write(iso,*) 
        write(iso,'(1x,a)') '# information of parallelization'
        write(iso,'(2x,a,I0)') '(number of processes) = ',np_dmrg
!$      write(iso,'(2x,a,I0)') 
!$   &  '(number of threads) = ',omp_get_max_threads()
      end if

! --- DYNAMICAL DMRG INPUT
      if(myid_dmrg.eq.key_rank) then
        open(10,file=file_ddmrg,status='old',err=998)
        id_ddmrg=1
        allocate(ddmrg(1))
        ios=0
        do while(ios.ge.0)
          read(10,'(a)',iostat=ios) para
          if(ios.lt.0) exit
          write(iso,'(1x,a)') para
          call trace_parameters(para)
        enddo
        close(10)
      end if
  998 continue

      call mpi_bcast(id_ddmrg,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(boundary,1,mpi_character,key_rank,newcomm_dmrg,
     &               ierr)

      if(id_ddmrg.eq.1) then
        if(myid_dmrg.ne.key_rank) then
          allocate(ddmrg(1))
        end if
        call mpi_bcast(ddmrg(1)%nop,1,mpi_integer,key_rank,
     &                 newcomm_dmrg,ierr)
        if(myid_dmrg.ne.key_rank) then
          allocate(ddmrg(1)%iop(ddmrg(1)%nop))
        end if
        call mpi_bcast(ddmrg(1)%iop,ddmrg(1)%nop,mpi_integer,key_rank,
     &                 newcomm_dmrg,ierr)

        call mpi_bcast(ddmrg(1)%nsg,1,mpi_integer,key_rank,
     &                 newcomm_dmrg,ierr)

        call mpi_bcast(ddmrg(1)%qx,1,MPI_REAL8,key_rank,
     &                 newcomm_dmrg,ierr)
        call mpi_bcast(ddmrg(1)%qy,1,MPI_REAL8,key_rank,
     &                 newcomm_dmrg,ierr)

        call mpi_bcast(ddmrg(1)%wmin,1,MPI_REAL8,key_rank,
     &                 newcomm_dmrg,ierr)
        call mpi_bcast(ddmrg(1)%wmax,1,MPI_REAL8,key_rank,
     &                 newcomm_dmrg,ierr)

        call mpi_bcast(ddmrg(1)%nw,1,mpi_integer,key_rank,
     &                 newcomm_dmrg,ierr)

        call mpi_bcast(ddmrg(1)%sigma,1,MPI_REAL8,key_rank,
     &                 newcomm_dmrg,ierr)

      end if

      return

  999 continue

! --- MAKING NEW 'parameters.txt''
      if(myid_dmrg.eq.key_rank) then
        open(10,file=file_param,status='new')
        write(10,'(a)') '# DMRG parameters'
        write(10,'(a)') '(DMRG truncation number) = 1000'
        write(10,'(a)') '(number of sweep) = 4'
        write(10,'(a)') ''
        write(10,'(a)') '# system parameters'
        write(10,'(a)') '(up-spin) = 8'
        write(10,'(a)') '(down-spin) = 8'
        close(10)
        write(iso,'(1x,a,a)') file_param,' is cleated.'

        open(10,file=file_ddmrg,status='new',err=1000)
        write(10,'(a)') '# DDMRG parameters'
        write(10,'(a)') '(number of sweep for ground state) = 2'
        write(10,'(a)') ''
        write(10,'(a)') '# operator'
        write(10,'(a)') '(number of operators): 1'
        write(10,'(a)') '(types of operators): 4'
        write(10,'(a)') ''
        write(10,'(a)') '# wavenumber'
        write(10,'(a)') '(wavenumber q_x) = 6*pi/6'
        write(10,'(a)') '(wavenumber q_y) = 0*pi/6'
        write(10,'(a)') '(boundary condition): c'
        write(10,'(a)') ''
        write(10,'(a)') '# parameters for energy range'
        write(10,'(a)') '(lower bound) =   0.000'
        write(10,'(a)') '(upper bound) =   8.000'
        write(10,'(a)') '(number of points) = 81'
        write(10,'(a)') '(half width of delta function) =   0.400'
        close(10)
        write(iso,'(1x,a,a)') file_param,' is cleated.'
 1000   continue
      end if

      call mpi_abort(newcomm_dmrg,ierr)
      stop

      end
