      subroutine sbessel(mab,pj,x)
      implicit real(8)(a-h,o-z)
      dimension pj(0:mab)
      real(8), allocatable :: t(:), b(:)

!$OMP PARALLEL WORKSHARE
      pj=0.d0
!$OMP END PARALLEL WORKSHARE

      if(abs(x).lt.1.d-15) then
        pj(0)=1.d0
        return
      end if

      pj(0)=sin(x)/x
      pj(1)=(sin(x)-x*cos(x))/(x*x)

      do n=2,mab
        if(dble(n).lt.x) then
          pj(n)=((2.d0*dble(n)-1.d0)/x)*pj(n-1)-pj(n-2)
          cycle
        end if

        k=int(((3.d0+2.8d0*sqrt(dble(n)))*x)/dble(n)+5.2d0)
        allocate(t(k+2),b(n))

        t(k+2)=0.d0
        do i=k+1,2,-1
          t(i)=(x*x)/(2.d0*dble(i+n-1)-t(i+1)+1.d0)
        enddo
        t(1)=x/(2.d0*dble(n)-t(2)+1.d0)

        b(n)=t(1)
        b(n-1)=1.d0
        do i=n-2,1,-1
          b(i)=((2.d0*dble(i)+3.d0)/x)*b(i+1)-b(i+2)
        enddo

        k0=int(mod(1.27324d0*x,4.d0))
        if(k0.eq.0.or.k0.eq.3) then
          b0=b(1); pj0=pj(1)
        else
          b0=(3.d0*b(1))/x-b(2); pj0=pj(0)
        end if

        pj(n)=t(1)*pj0/b0

        if(pj(n).lt.1.d-200) then
          pj(n)=0.d0
        end if

        if(abs(pj(n))+abs(pj(n-1)).lt.1.d-200) then
          deallocate(t,b)
          return
        end if
        deallocate(t,b)
      enddo

      return
      end

