      subroutine set_dmrg()
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ix1,ix2

      time(1)=mpi_wtime()

! --- INITIALIZE VALIABLES
! --- PHYSICAL QUANTITIES
      ene_t=0.d0
      ee_t=0.d0
      err_t=0.d0

! --- ADDED SITES
      nfrx(1)=nfr**nas
      nfrx(2)=nfr**nae
      iad(1)=nse(1)+1
      iad(2)=nsite-nse(2)

      allocate(ad(nfrx(1),nfrx(2)))
!$OMP PARALLEL DO
      do ix2=1,nfrx(2)
        do ix1=1,nfrx(1)
          ad(ix1,ix2)=ix1+nfrx(1)*(ix2-1)
        enddo
      enddo

! --- BLOCKS
      if(.not.allocated(ndmx)) allocate(ndmx(2))
      ndmx(1)=sum(block(1,nse(1),mh)%size)
      ndmx(2)=sum(block(2,nse(2),mh)%size)

! --- NUMBER OF SPIN
      if(id_spin.ge.1) then !filled spins for spin model
        limdw=id_spin*(nse(1)+nse(2)+nadd)-limup
      end if

! --- SWEEPS
      if(mdDMRG.eq.0.or.mdDMRG.eq.3) then
        isweep=0 
        if(idmrg.eq.ndmrg_i) then
          iphys=1
          icphys=0
          phys(1)%isw(0)=maxval(ndmx)
        else
          iphys=0
        end if
      else
        if(if_tdmrg.eq.1) then
          ix1=idmrg-ndmrg_i-ndmrg_ex-ndmrg_s*nsweep_g
          isweep=(idmrg-ndmrg_i)/ndmrg_s
          if(mod(ix1,ndmrg_s*ns_ech).eq.0) then
            iphys=1
            ich_time=0
          elseif(mod(ix1,ndmrg_s*ns_ech).eq.1) then
            iphys=0
            icphys=icphys+1
            ich_time=1
          else
            iphys=0
            ich_time=0
          end if
        else
          ix1=idmrg-ndmrg_i
          isweep=(idmrg-ndmrg_i)/ndmrg_s
          if(mod(ix1,ndmrg_s*ns_ech).eq.0) then
            iphys=1
            ich_time=0
          elseif(mod(ix1,ndmrg_s*ns_ech).eq.1) then
            iphys=0
            if(idmrg.le.ndmrg_i+ndmrg_s*nsweep_g) icphys=icphys+1
            ich_time=1
          else
            iphys=0
            ich_time=0
          end if
        end if

! ----- SETTING OF tDMRG
        if(id_tdmrg.eq.1) then
          if((idmrg-1-ndmrg_i-ndmrg_ex)/ndmrg_s.ge.nsweep_g) then !tDMRG
            if_tdmrg=1
            if(id_mapping.eq.1) mh=2
            if(mod(ix1,ndmrg_dt).eq.1) then !tDMRG
              if(iswp_ev.ge.tdmrg(itdmrg)%ns) then
                itdmrg=itdmrg+1
                if(myid_dmrg.eq.key_rank) then
                  write(iso,'(1x,a,I0,a,I0)') '# change event :',
     &              tdmrg(itdmrg-1)%ks,' --> ',tdmrg(itdmrg)%ks
                end if
                iswp_ev=0
              end if
              if(tdmrg(itdmrg)%ks.eq.0) then
              elseif(tdmrg(itdmrg)%ks.eq.1) then !laser
              end if
              iswp_ev=iswp_ev+1
            else
            end if
          end if
        end if
        phys(1)%isw(icphys)=max(maxval(ndmx),phys(1)%isw(icphys))
      end if

! --- LASER
      if(id_tdmrg.eq.1) then
        if(tdmrg(itdmrg)%ks.eq.1) then
          call laser(ps)
        else
          ps=one
        end if
      else
        ps=one
      end if

! --- COMFIRMATION SYSTEM
      call make_state(nse(1),nse(2),mh)

! --- LANCZOS PARAMETERS
      if(idmrg.eq.ndmrg.or.iwf.ne.1) then
        mab2=min(int(ndimsp,kind=4),mab1)
      elseif(allocated(ddmrg)) then
        if(mdDMRG.ne.0.and.isweep.gt.ddmrg(1)%nsg-1) then
          mab2=min(int(ndimsp,kind=4),mab1)
        else
          mab2=min(int(ndimsp,kind=4),mab0)
        end if
      else
        mab2=min(int(ndimsp,kind=4),mab0)
      end if

! --- INITIALIZE MPI PARALLELIZATION
      call init_mpi_bk(0) !BLOCK
      call init_mpi_vec(0)        !VECTOR

! --- OUTPUT INFORMATION
      if(myid_dmrg.eq.key_rank) then
        write(iso,*)
        if(mdDMRG.eq.0.or.mdDMRG.eq.3) then
          write(iso,'(1x,a,I0,a,I0,a,I0,a,I0,a)') 
     &      '# progress: ',idmrg,'/',ndmrg,
     &      ' [infinite: ',idmrg,'/',ndmrg_i,']'
        else
          write(iso,'(1x,a,I0,a,I0,a,I0,a,I0,a,I0,a,I0,a)') 
     &      '# progress: ',idmrg,'/',ndmrg,
     &      ' [finite: ',idmrg-ndmrg_i,'/',ndmrg_f,
     &      ' (',isweep,'/',nsweep,')]'
        end if
        write(iso,'(1x,a)') '# superblock information: '
        write(iso,'(2x,a,I0)') '(number of sites) = ',nse(1)+nse(2)+nadd
        if(id_space.eq.1) then
          if(id_spinless.eq.1) then
            write(iso,'(2x,a,I0)') '(number of fermion) = ',limup
          else
            write(iso,'(2x,a,I0,a,I0)')
     &      '(up-spin) = ',limup,', (down-spin) = ',limdw
          end if
        end if
        write(iso,'(2x,a,I0,a,I0,a,I0,a)') 
     &  '[system: ',nse(1),']-[added: ',nadd,
     &  ']-[environment: ',nse(2),']'
        write(iso,'(2x,a,I0)')
     &  '(dimension of sys.-block) = ',ndmx(1)
        write(iso,'(2x,a,I0)')
     &  '(dimension of env.-block) = ',ndmx(2)
        write(iso,'(2x,a,I0)')
     &    '(dimension of superblock) = ',ndimsp
        write(iso,'(2x,a,I0,1x,a,I0,a)') 
     &    '(number of blocks) = ',nbk,'(/',np_bk,')'
      end if

      return
      end
