      subroutine set_input()
      implicit none
      integer :: nsu,idm,nsr,ix1,ix2,ix3,ios,mx1,mx2,mc,mk,id_c
      real(8) :: v,pi2
      integer,allocatable :: iu2(:,:),il2(:,:),id(:),ns(:)
      real(8),allocatable :: c(:,:),u(:,:),d(:,:),a(:,:),b(:,:)
      character(64) :: para

      write(6,'(a)') "# Make input file"
      write(6,'(4x,a)',advance='no') 
     &  "(preset.txt: 1, position.txt: 2): "
      read(5,*) idm

      select case(idm)
      case(1)
        id_c=0
        mk=20
        open(7,file='preset.txt')

        write(6,'(a)') "# Information of Hamiltonian"
        write(6,'(4x,a)',advance='no') 
     &      "Number of coefficient: "
        read(5,*) mc
        write(6,'(4x,a)',advance='no') 
     &      "Make dataset of coefficient (Y/N): "
        read(5,'(a)') para

        if(index(para,'S').ne.0.or.index(para,'s').ne.0) then
          id_c=1
          write(6,'(a)') "# Dzyaloshinskii-Moriya interaction"
          write(6,'(4x,a)',advance='no')
     &        "Coefficient: "
          read(5,*) v
          allocate(d(mc,3))
          d(:,1)=(/-1.d0,0.d0,0.d0,0.d0,-1.d0,v,0.d0,-v,-1.d0/)
          d(:,2)=(/-1.d0,0.d0,-v,0.d0,-1.d0,0.d0,v,0.d0,-1.d0/)
          d(:,3)=(/-1.d0,v,0.d0,-v,-1.d0,0.d0,0.d0,0.d0,-1.d0/)
        elseif(index(para,'Y').ne.0.or.index(para,'y').ne.0) then
          id_c=1
          allocate(d(mc,mk))
          do ix1=1,mk
            write(6,'(4x,I0,a)',advance='no') ix1,": "
            read(5,'(a)') para
            if(len_trim(para).eq.0) exit
            read(para,*) d(:,ix1)
          enddo
          if(ix1-1.eq.0) id_c=0
        end if

        write(6,'(a)') "# Information of unit cell"
        write(6,'(4x,a)',advance='no') 
     &      "Number of sites in a cell: "
        read(5,*) nsu
        if(nsu.gt.1) then
          if(id_c.eq.1) then
            allocate(id((nsu*(nsu+1))/2))
            id=0
          end if
          allocate(u(mc,(nsu*(nsu+1))/2),iu2(2,(nsu*(nsu+1))/2))
          u=0.d0
          iu2=0
          write(6,'(a)') 
     &        "# Interactions between 2 sites of INTRA-CELL"
          mx1=0
          do ix1=1,(nsu*(nsu+1))/2
            if(id_c.eq.1) then
              write(6,'(4x,a)',advance='no') 
     &            "(site 1) (site 2) (data number): "
            else
              write(6,'(4x,a)',advance='no') 
     &            "(site 1) (site 2) (coefficient): "
            end if
            read(5,'(a)',iostat=ios) para
            if(ios.lt.0) exit
            if(len_trim(para).eq.0) exit

            if(index(para,'N').ne.0) then
              do ix2=1,nsu-1
                iu2(1,ix2)=ix2
                iu2(2,ix2)=ix2+1
                if(len_trim(para(index(para,'N')+1:)).gt.0) then
                  if(id_c.eq.1) then
                    read(para(index(para,'N')+1:),*) id(ix2)
                  else
                    read(para(index(para,'N')+1:),*) u(1:mc,ix2)
                  end if
                else
                  if(id_c.eq.1) then
                    id(ix2)=1
                  else
                    u(1:mc,ix2)=1.d0
                  end if
                end if
              enddo
              mx1=nsu-1

              write(6,'(4x,a)',advance='no')
     &          "Boundary condition (open: o, periodic: p): "
              read(5,'(a)',iostat=ios) para
              if(index(para,'p').ne.0) then
                iu2(1,nsu)=1
                iu2(2,nsu)=nsu
                if(len_trim(para(index(para,'p')+1:)).gt.0) then
                  if(id_c.eq.1) then
                    read(para(index(para,'p')+1:),*) id(nsu)
                  else
                    read(para(index(para,'p')+1:),*) u(1:mc,nsu)
                  end if
                else
                  if(id_c.eq.1) then
                    id(nsu)=1
                  else
                    u(1:mc,nsu)=u(1:mc,nsu-1)
                  end if
                end if
                mx1=mx1+1
              end if
              exit
            end if

            if(id_c.eq.1) then
              read(para,*,err=1000) iu2(1:2,ix1),id(ix1)
            else
              read(para,*,err=1000) iu2(1:2,ix1),u(1:mc,ix1)
            end if
            mx1=mx1+1
          enddo
 1000     continue
          write(6,'(4x,a,I0)') 'Number of interactions: ',mx1
        end if

        write(6,'(a)') "# Information of lattice"
        write(6,'(4x,a)',advance='no') "Number of unit cells: "
        read(5,*) nsr

        if(nsu.gt.1) then
          do ix2=1,nsr
            do ix1=1,mx1
              write(7,'(1x,I0,1x,I0)',advance='no') 
     &          iu2(1,ix1)+nsu*(ix2-1),iu2(2,ix1)+nsu*(ix2-1)
              if(id_c.eq.1) then
                do ix3=1,mc
                  write(7,'(1x,f8.3)',advance='no') d(ix3,id(ix1))
                enddo
              else
                do ix3=1,mc
                  write(7,'(1x,f8.3)',advance='no') u(ix3,ix1)
                enddo
              end if
              write(7,*)
            enddo
          enddo
        end if

        if(nsr.gt.1) then
          allocate(c(mc,(nsu*(nsu+1))/2),il2(2,(nsu*(nsu+1))/2))
          if(id_c.eq.1) id=0
          c=0.d0
          il2=0
          write(6,'(a)') 
     &        "# Interactions between 2 sites of INTER-CELL"
          mx2=0
          do ix1=1,(nsu*(nsu+1))/2
            if(id_c.eq.1) then
              write(6,'(4x,a)',advance='no') 
     &            "(site 1) (site 2) (data number): "
            else
              write(6,'(4x,a)',advance='no')
     &            "(site 1) (site 2) (coefficient): "
            end if
            read(5,'(a)',iostat=ios) para
            if(ios.lt.0) exit
            if(len_trim(para).eq.0) exit

            if(index(para,'N').ne.0) then
              do ix2=1,nsu
                il2(1,ix2)=ix2
                il2(2,ix2)=ix2
                if(len_trim(para(index(para,'N')+1:)).gt.0) then
                  if(id_c.eq.1) then
                    read(para(index(para,'N')+1:),*) id(ix2)
                  else
                    read(para(index(para,'N')+1:),*) c(1:mc,ix2)
                  end if
                else
                  if(id_c.eq.1) then
                    id(ix2)=1
                  else
                    c(1:mc,ix2)=1.d0
                  end if
                end if
              enddo 
              mx2=nsu
              exit
            end if

            if(id_c.eq.1) then
              read(para,*,err=1001) il2(1:2,ix1),id(ix1)
            else
              read(para,*,err=1001) il2(1:2,ix1),c(1:mc,ix1)
            end if
            mx2=mx2+1
          enddo
 1001     continue

          do ix2=1,nsr-1
            do ix1=1,mx2
              write(7,'(1x,I0,1x,I0)',advance='no') 
     &          il2(1,ix1)+nsu*(ix2-1),il2(2,ix1)+nsu*ix2
              if(id_c.eq.1) then
                do ix3=1,mc
                  write(7,'(1x,f8.3)',advance='no') d(ix3,id(ix1))
                enddo
              else
                do ix3=1,mc
                  write(7,'(1x,f8.3)',advance='no') c(ix3,ix1)
                enddo
              end if
              write(7,*)
            enddo
          enddo

          write(6,'(2x,a)',advance='no')
     &      "Boundary condition (open: o, periodic: p): "
          read(5,'(a)',iostat=ios) para
          if(index(para,'p').ne.0) then
            do ix1=1,mx2
              write(7,'(1x,I0,1x,I0)',advance='no')
     &          il2(1,ix1),il2(2,ix1)+nsu*nsr
              if(id_c.eq.1) then
                do ix3=1,mc
                  write(7,'(1x,f8.3)',advance='no') d(ix3,id(ix1))
                enddo
              else
                do ix3=1,mc
                  write(7,'(1x,f8.3)',advance='no') c(ix3,ix1)
                enddo
              end if
              write(7,*)
            enddo
          end if
        end if

        if(allocated(c)) deallocate(c)
        if(allocated(u)) deallocate(u)
        if(allocated(id)) deallocate(id)
        if(allocated(iu2)) deallocate(iu2)
        if(allocated(il2)) deallocate(il2)
        close(7)

      case(2)
        allocate(a(2,2),ns(2))
        write(6,'(a)') "# Primitive vector" 
        write(6,'(2x,a)',advance='no') "a_1: (x,y) = "
        read(5,'(a)') para
        ix1=index(para,'(')+1
        ix2=index(para,',')-1
        call pcal(para(ix1:ix2),a(1,1))
        ix1=index(para,',')+1
        ix2=index(para,')')-1
        if(ix2.eq.0) ix2=64
        call pcal(para(ix1:ix2),a(2,1))
        write(6,'(2x,a)',advance='no') "a_2: (x,y) = "
        read(5,'(a)') para
        ix1=index(para,'(')+1
        ix2=index(para,',')-1
        call pcal(para(ix1:ix2),a(1,2))
        ix1=index(para,',')+1
        ix2=index(para,')')-1
        if(ix2.eq.0) ix2=64
        call pcal(para(ix1:ix2),a(2,2))

        write(6,'(a)') "# Number of site" 
        write(6,'(2x,a)',advance='no') "a_1 direction:  "
        read(5,*) ns(1)
        write(6,'(2x,a)',advance='no') "a_2 direction:  "
        read(5,*) ns(2)

        open(7,file='position.txt')
        do ix1=1,ns(1)
          do ix2=1,ns(2)
            write(7,'(1x,I0,1x,f9.4,1x,f9.4)')
     &        ix2+ns(2)*(ix1-1),
     &        a(1,1)*dble(ix1)+a(1,2)*dble(ix2),
     &        a(2,1)*dble(ix1)+a(2,2)*dble(ix2)
          enddo
        enddo
        close(7)

        allocate(b(2,2))
        pi2=8.d0*atan(1.d0)
        v=a(1,1)*a(2,2)+a(2,1)*a(1,2)
        b(1,1)=pi2*a(2,2)/v
        b(2,1)=-pi2*a(1,2)/v
        b(1,2)=-pi2*a(2,1)/v
        b(2,2)=pi2*a(1,1)/v
        write(6,'(a)') "# Reciprocal lattice vector" 
        write(6,'(2x,a,f9.5,a,f9.5,a)') "b_1 = (",b(1,1),",",b(2,1),")"
        write(6,'(2x,a,f9.5,a,f9.5,a)') "b_2 = (",b(1,2),",",b(2,2),")"

        deallocate(a,ns)
      end select

      return
      end
