      subroutine target_state()
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ib,ndimx,iv,neg,ix,ibk_size,ms,ih
      integer(8) :: imem
      integer,allocatable :: ns(:),ks(:)

      ih=1
      time(3)=mpi_wtime()

! --- CONFIMATION OF DIMENSION
      if(mdDMRG.eq.0.and.idmrg.ne.ndmrg) then
        ndimx=0
!$OMP PARALLEL DO REDUCTION(+:ndimx)
        do ib=1,nbk
          ndimx=ndimx+bk(ib,1,ih)%size
        enddo

        if(nas*nae.eq.0) then
          if(ndimx*nfr.lt.mts.and.etr.eq.0.d0.and.
     &      nse(1)+nse(2)+nadd.lt.nsite) then
            return
          end if
        else
          if(ndimx.lt.mts.and.etr.eq.0.d0.and.
     &      nse(1)+nse(2)+nadd.lt.nsite) then
            return
          end if
        end if
      end if

! --- INITIALIZE TARGET-STATE
      if(allocated(ddmrg)) then
        neg=1
        if(mdDMRG.ne.0.and.isweep.gt.ddmrg(1)%nsg-1) then
          ntargd=1+2+4*ddmrg(1)%nw !cos,sin,Re,Im
        else
          ntargd=1
        end if
      elseif(if_tdmrg.eq.1) then
        neg=1
        if(id_multi.eq.0) then
          ntargd=1
        else
          ntargd=1+tdmrg(itdmrg)%is
        end if
      else
        neg=num_eigen
        ntargd=neg
      end if
      if(myid_dmrg.eq.key_rank) then
        write(iso,'(2x,a,I0)')
     &    '(number of target states) = ',ntargd
      end if

      if(if_tdmrg*id_mapping.ne.0) call change_space(1)
      allocate(v(isbk1:iebk1,ntargd))
      ibk_size=max(iebk1-isbk1+1,0)
      mem_ts=0
      do ix=1,ntargd
        call lz_acv(v(isbk1:iebk1,ix),isbk1,iebk1,1,imem)
        mem_ts=mem_ts+imem
      enddo

      if(if_tdmrg*id_mapping.ne.0) then
        call trans_wfunc2(1,1)
        call vcopy(v(isbk1:iebk1,1),v(isbk1:iebk1,2))
        call wfunc_tmat(1,2)
        call change_space(2)
      else
        call trans_wfunc2(1,1)
      end if

      allocate(time_test(0:26))
      time_test(8:13)=0.d0
      time_test(0)=mpi_wtime()

! --- TARGET STATE CALCULATONS
      if(if_tdmrg.eq.1) then
! ----- TIME EVOLUTION
        call tdmrg_target()
      else
! ----- EIGEN STATE (DMRG,DDMRG)
        call lanczos(v(:,1:neg),neg,mab2)

! ----- EXCITED STATES (DDMRG)
        if(allocated(ddmrg).and.mdDMRG.ne.0) then
          call ddmrg_target()
        end if

! ----- PHYSICAL QUANTITIES (STATEC)
c        if(mdDMRG.ne.0) then
c        if(iphys.eq.1.or.mdDMRG.ne.0) then
        if(iphys.eq.1) then
          if(myid_dmrg.eq.key_rank) then
            write(iso,'(1x,a)') '# physical quantities'
          end if
          do iv=1,neg
            if(myid_dmrg.eq.key_rank) then
              write(iso,'(1x,a,I0)') '# state ',iv
            end if
            call phys_main(iv)
            if(idmrg.eq.ndmrg) call qphys_main(iv)

            if(id_tdmrg.eq.1.and.mdDMRG.ne.0.and.mdDMRG.ne.3) then !initial state of tDMRG
              if(myid_dmrg.eq.key_rank) then
                write(iso,*)
                write(iso,'(1x,a,2x,f12.7)') '# (time): ',0.d0
              end if

              if(id_spin.eq.0) then !ELECTRON MODEL
                if(idmrg.eq.ndmrg_i+ndmrg_s*nsweep_g) then
                  if(id_current.eq.1) call current_1D(iv)
                  if(id_doublon.eq.1) call doublon(iv)
                end if
              elseif(id_spin.ge.1) then !SPIN MODEL
              end if
            end if
          enddo
        end if
      end if

#ifdef dep
      time_test(14)=mpi_wtime()-time_test(0)
      call mpi_allreduce(time_test(8),time_test(15),1,
     &                 mpi_double_precision,mpi_max,newcomm_dmrg,ierr)
      call mpi_allreduce(time_test(9),time_test(16),1,
     &                 mpi_double_precision,mpi_max,newcomm_dmrg,ierr)
      call mpi_allreduce(time_test(10),time_test(17),1,
     &                 mpi_double_precision,mpi_max,newcomm_dmrg,ierr)
      call mpi_allreduce(time_test(11),time_test(18),1,
     &                 mpi_double_precision,mpi_max,newcomm_dmrg,ierr)
      call mpi_allreduce(time_test(12),time_test(19),1,
     &                 mpi_double_precision,mpi_max,newcomm_dmrg,ierr)
      call mpi_allreduce(time_test(13),time_test(20),1,
     &                 mpi_double_precision,mpi_max,newcomm_dmrg,ierr)

      call mpi_allreduce(time_test(8),time_test(21),1,
     &                 mpi_double_precision,mpi_min,newcomm_dmrg,ierr)
      call mpi_allreduce(time_test(9),time_test(22),1,
     &                 mpi_double_precision,mpi_min,newcomm_dmrg,ierr)
      call mpi_allreduce(time_test(10),time_test(23),1,
     &                 mpi_double_precision,mpi_min,newcomm_dmrg,ierr)
      call mpi_allreduce(time_test(11),time_test(24),1,
     &                 mpi_double_precision,mpi_min,newcomm_dmrg,ierr)
      call mpi_allreduce(time_test(12),time_test(25),1,
     &                 mpi_double_precision,mpi_min,newcomm_dmrg,ierr)
      call mpi_allreduce(time_test(13),time_test(26),1,
     &                 mpi_double_precision,mpi_min,newcomm_dmrg,ierr)
      if(myid_dmrg.eq.key_rank) then
        write(iso,'(2x,a,f11.5,a,f11.5,a)') 
     &      'vector:  ',time_test(15),' --',time_test(21),' [s]'
        write(iso,'(2x,a,f11.5,a,f11.5,a)') 
     &      'DGEMM:   ',time_test(16),' --',time_test(22),' [s]'
        write(iso,'(2x,a,f11.5,a,f11.5,a)') 
     &      'block:   ',time_test(19),' --',time_test(25),' [s]'
        write(iso,'(2x,a,f11.5,a,f11.5,a)') 
     &      'added:   ',time_test(18),' --',time_test(24),' [s]'
        write(iso,'(2x,a,f11.5,a,f11.5,a)') 
     &      'matrix:  ',time_test(17),' --',time_test(23),' [s]'
        write(iso,'(2x,a,f11.5,a,f11.5,a)') 
     &      'interact:',time_test(20),' --',time_test(26),' [s]'
        write(iso,'(2x,a,f11.5,a)') 
     &      'target:  ',time_test(14),' [s]'
      end if
#endif
      deallocate(time_test)

      return
      end
