      subroutine tdep_rpm(vin,vout)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iz,n,n1,n2,ib,i,k,ix1,ix2,ix,mx1,maxt0,maxt,ih
      integer(8) :: imem
      real(8) :: wp,an,cn,dn,en,pan,san,sigma2,ax(2),wx
      complex(8) :: zwp
      real(8),allocatable :: p(:,:),tm(:)
      type(avec) :: vin(isbk1:iebk1),vout(isbk1:iebk1,tdmrg(itdmrg)%is)
      type(avec),allocatable :: pv(:,:)
#ifdef t_RPM
      type(avec),allocatable :: dpv(:,:)
#endif

      ih=1

! --- PARAMETERS
      maxt0=100
      ax=(/pi,two/)
      mx1=nfrx(1)*nfrx(2)*(iebk1-isbk1+1)

! --- COEFFICIENT
      allocate(p(0:maxt0,tdmrg(itdmrg)%is),tm(tdmrg(itdmrg)%is))
      do iz=1,tdmrg(itdmrg)%is
        tm(iz)=(tdmrg(itdmrg)%ts/dble(tdmrg(itdmrg)%is))*dble(iz)/pwt
        call sbessel(maxt0,p(0:maxt0,iz),tm(iz))
      enddo
      maxt=maxt0
      do iz=1,maxt0
        if(abs(p(iz,tdmrg(itdmrg)%is)/p(0,tdmrg(itdmrg)%is)).lt.
     &       1.d-16) then
          maxt=iz
          if(myid_dmrg.eq.key_rank) then
            write(iso,'(2x,a,I0)') '(KPM truncation number) = ',maxt
          end if
          exit
        end if
      enddo

#ifdef t_RPM
      sigma2=(2.d0*pi/dble(maxt))**2
#else
      sigma2=0.d0
#endif

! --- INITIALIZE RPM
      allocate(pv(isbk0:iebk0,2))
      call lz_acv(pv(isbk0:iebk0,1),isbk0,iebk0,0,imem)
      call lz_acv(pv(isbk0:iebk0,2),isbk0,iebk0,0,imem)
#ifdef t_RPM
      allocate(dpv(isbk1:iebk1,2))
      call lz_acv(dpv(isbk1:iebk1,1),isbk1,iebk1,1,imem)
      call lz_acv(dpv(isbk1:iebk1,2),isbk1,iebk1,0,imem)
#endif

! --- 0th order
! ----- POLYNOMIAL
      call vcopy(vin,pv(isbk1:iebk1,1))
      call rpm_bcast(pv(isbk0:iebk0,1))
      do iz=1,tdmrg(itdmrg)%is
        wp=p(0,iz)*exp((sigma2*tm(iz)*tm(iz))*0.5d0)
!$OMP PARALLEL DO PRIVATE(ib,i,k)
        do ix=1,mx1
          ib=(ix-1)/(nfrx(1)*nfrx(2))+isbk1
          i=mod((ix-1)/nfrx(2),nfrx(1))+1
          k=mod(ix-1,nfrx(2))+1
          do ix2=bk(ib,2,ih)%ivs(k),bk(ib,2,ih)%ive(k)
            do ix1=bk(ib,1,ih)%ivs(i),bk(ib,1,ih)%ive(i)
              vout(ib,iz)%ap(ad(i,k))%b(ix1,ix2)
     &          =wp*pv(ib,1)%ap(ad(i,k))%b(ix1,ix2)
            enddo
          enddo
        enddo
      enddo

! --- 1st order
      wx=-pwt*psf
! ----- POLYNOMIAL
!$OMP PARALLEL DO PRIVATE(ib,i,k)
      do ix=1,mx1
        ib=(ix-1)/(nfrx(1)*nfrx(2))+isbk1
        i=mod((ix-1)/nfrx(2),nfrx(1))+1
        k=mod(ix-1,nfrx(2))+1
        do ix2=bk(ib,2,ih)%ivs(k),bk(ib,2,ih)%ive(k)
          do ix1=bk(ib,1,ih)%ivs(i),bk(ib,1,ih)%ive(i)
            pv(ib,2)%ap(ad(i,k))%b(ix1,ix2)
     &        =wx*pv(ib,1)%ap(ad(i,k))%b(ix1,ix2)
          enddo
        enddo
      enddo
#ifdef t_RPM
      call vcopy(vin,dpv(isbk1:iebk1,2))
#endif
      call rpm_bcast(pv(isbk0:iebk0,2))
      call matrix_vec(1,pv(:,1),pv(:,2),pwt*one)
      do iz=1,tdmrg(itdmrg)%is
        zwp=cmplx(0.d0,-3.d0,kind=8)*p(1,iz)
     &      *exp((sigma2*tm(iz)*tm(iz))*0.5d0)
        call vaxpy(pv(isbk1:iebk1,2),vout(isbk1:iebk1,iz),zwp)
      enddo

! --- HIGHER ORDER
      do n=2,maxt
        call rpm_coeff(n,sigma2,pwt,psf,n1,n2,wp,an,cn,dn,en,pan,san)
! ----- POLYNOMIAL
!$OMP PARALLEL DO PRIVATE(ib,i,k)
        do ix=1,mx1
          ib=(ix-1)/(nfrx(1)*nfrx(2))+isbk1
          i=mod((ix-1)/nfrx(2),nfrx(1))+1
          k=mod(ix-1,nfrx(2))+1
          do ix2=bk(ib,2,ih)%ivs(k),bk(ib,2,ih)%ive(k)
            do ix1=bk(ib,1,ih)%ivs(i),bk(ib,1,ih)%ive(i)
              pv(ib,n2)%ap(ad(i,k))%b(ix1,ix2)
     &          =cn*pv(ib,n2)%ap(ad(i,k))%b(ix1,ix2)
     &            +san*pv(ib,n1)%ap(ad(i,k))%b(ix1,ix2)
#ifdef t_RPM
     &            +dn*dpv(ib,n1)%ap(ad(i,k))%b(ix1,ix2)
#endif
            enddo
          enddo
        enddo
#ifdef t_RPM
        call vaxpy(pv(isbk1:iebk1,n1),dpv(isbk1:iebk1,n2),en)
#endif
        call rpm_bcast(pv(isbk0:iebk0,n2))
        call matrix_vec(1,pv(:,n1),pv(:,n2),pan*one)
        do iz=1,tdmrg(itdmrg)%is
          zwp=(2.d0*(dble(n)+0.5d0))
     &        *(cmplx(0.d0,-1.d0,kind=8)**n)*p(n,iz)
     &        *exp((sigma2*tm(iz)*tm(iz))*0.5d0)
          call vaxpy(pv(isbk1:iebk1,n2),vout(isbk1:iebk1,iz),zwp)
        enddo
      enddo !END OF SUM.

      deallocate(p,pv,tm)
#ifdef t_RPM
      deallocate(dpv)
#endif

      return
      end
