      subroutine trabset(ise,ib,jb,hot,nx,mhx,b)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ise,ib,jb,nx,i,jsize,jsta,jend,lsta,lend,lsize,mhx
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) ::
#endif
     &  hot(block(ise,nx,mhx)%size(jb),block(ise,nx,mhx)%size(ib)),
     &  b
#ifdef cmplx_v
      complex(8),
#else
      real(8),
#endif
     &  allocatable :: ht1(:,:),ht2(:,:)

      if(block(ise,nx,mhx)%size(ib).gt.0.and.
     &   block(ise,nx,mhx)%size(jb).gt.0) then

        jsta=block(ise,nx,mhx)%ista0(jb,1)
        jend=min(block(ise,nx,mhx)%iend0(jb,1),
     &           block(ise,nx,mhx)%size(jb))
        jsize=max(jend-jsta+1,0)

        allocate(ht1(jsize,block(ise,nx,mhx)%size0(ib)))
!$OMP PARALLEL WORKSHARE
        ht1=zero
!$OMP END PARALLEL WORKSHARE

        do i=1,nfr
          call para_range(1,block(ise,nx,mhx)%sizex(ib,i),
     &                    np_env,myid_env,lsta,lend)
          lsize=lend-lsta+1

          if(lsize.gt.0.and.jsize.gt.0.and.
     &       block(ise,nx,mhx)%size0(ib).gt.0) then
            call XGEMM(chmm(2),chmm(1),
     &                 jsize,
     &                 block(ise,nx,mhx)%size0(ib),
     &                 lsize,
     &                 one,
     &                 block(ise,nx,mhx)%b(jb)%s(i)%uv(:,jsta),
     &                 lsize,
     &                 ast(i,2)%ht,
     &                 lsize,
     &                 one,
     &                 ht1,
     &                 jsize)
          end if
        enddo

        allocate(ht2(jsize,block(ise,nx,mhx)%size0(ib)))

        call mpi_allreduce(ht1,ht2,jsize*block(ise,nx,mhx)%size0(ib),
     &                     mpi_kv,mpi_sum,newcomm_env,ierr)

        deallocate(ht1)

        allocate(ht1(block(ise,nx,mhx)%size(jb),
     &               block(ise,nx,mhx)%size0(ib)))

        call gc2d(ht2,jsize,block(ise,nx,mhx)%size0(ib),
     &            ht1,block(ise,nx,mhx)%size(jb),
     &            np_sys,newcomm_sys)

        deallocate(ht2)

        allocate(ht2(block(ise,nx,mhx)%size(jb),jsize))
!$OMP PARALLEL WORKSHARE
        ht2=zero
!$OMP END PARALLEL WORKSHARE

        do i=1,nfr
          call para_range(1,block(ise,nx,mhx)%sizex(ib,i),
     &                    np_env,myid_env,lsta,lend)
          lsize=lend-lsta+1

          if(jsize.gt.0.and.lsize.gt.0.and.
     &       block(ise,nx,mhx)%size(jb).gt.0) then
            call XGEMM(chmm(1),chmm(1),
     &                 block(ise,nx,mhx)%size(jb),
     &                 jsize,
     &                 lsize,
     &                 b,
     &                 ht1(:,block(ise,nx,mhx)%stax(ib,i)+lsta-1:
     &                       block(ise,nx,mhx)%stax(ib,i)+lend-1),
     &                 block(ise,nx,mhx)%size(jb),
     &                 block(ise,nx,mhx)%b(jb)%s(i)%uv(:,jsta:jend),
     &                 lsize,
     &                 one,
     &                 ht2,
     &                 block(ise,nx,mhx)%size(jb))
          end if
        enddo

        deallocate(ht1)

        allocate(ht1(block(ise,nx,mhx)%size(jb),jsize))
        call mpi_allreduce(ht2,ht1,block(ise,nx,mhx)%size(jb)*jsize,
     &                     mpi_kv,mpi_sum,newcomm_env,ierr)

        deallocate(ht2)

        call gr2d(ht1,block(ise,nx,mhx)%size(jb)*jsize,hot,
     &            np_sys,newcomm_sys)

        deallocate(ht1)
      end if

      return
      end
