      subroutine trace_parameters(para)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: i0,i1,ix
      character(64) para

! --- comment line
      if(index(para,'#').eq.1) return
      i1=index(para,'!')-1
      if(i1.eq.-1) then
        i1=64
      elseif(i1.eq.0) then
        return
      end if

! --- DMRG truncation number
      call trace_char_i(para,'(DMRG truncation number)',mts)

! --- number of sweep
      call trace_char_i(para,'(number of sweep)',nsweep_g)
      if(allocated(ddmrg))
     &  call trace_char_i(para,'(number of sweep for ground state)',
     &                    ddmrg(1)%nsg)

! --- boundary condition
      if(index(para,'boundary condition').ne.0) then
        i0=index(para,':')+1
        read(para(i0:i1),*) boundary
        return
      end if

! --- number of up-spin
      if(index(para,'up-spin').ne.0) then
        if(index(para,'+=').ne.0) then
          i0=index(para,'=')+1
          read(para(i0:i1),*) ix
          inup=max(1,id_spin)*(nsite/2)+mod(nsite,2)*(max(1,id_spin)/2)
     &         +ix
        elseif(index(para,'-=').ne.0) then
          i0=index(para,'=')+1
          read(para(i0:i1),*) ix
          inup=max(1,id_spin)*(nsite/2)+mod(nsite,2)*(max(1,id_spin)/2)
     &         -ix
        else
          i0=index(para,'=')+1
          read(para(i0:i1),*) inup
        end if
        return
      end if

! --- number of down-spin
      if(index(para,'down-spin').ne.0) then
        if(index(para,'+=').ne.0) then
          i0=index(para,'=')+1
          read(para(i0:i1),*) ix
          indw=max(1,id_spin)*(nsite/2)+ix
        elseif(index(para,'-=').ne.0) then
          i0=index(para,'=')+1
          read(para(i0:i1),*) ix
          indw=max(1,id_spin)*(nsite/2)-ix
        else
          i0=index(para,'=')+1
          read(para(i0:i1),*) indw
        end if
        return
      end if

! --- OPERATOR
      if(index(para,'number of operators').ne.0) then
        i0=index(para,':')+1
        read(para(i0:i1),*) ddmrg(1)%nop
        allocate(ddmrg(1)%iop(ddmrg(1)%nop))
        return
      end if

      if(index(para,'types of operators').ne.0) then
        i0=index(para,':')+1
        read(para(i0:i1),*) ddmrg(1)%iop
        return
      end if

! --- WAVENUMBER
      if(index(para,'wavenumber q_x').ne.0) then
        i0=index(para,'=')+1
        call pcal(para(i0:i1),ddmrg(1)%qx)
        write(iso,'(2x,a,f8.5)') 'q_x=',ddmrg(1)%qx
        return
      end if

      if(index(para,'wavenumber q_y').ne.0) then
        i0=index(para,'=')+1
        call pcal(para(i0:i1),ddmrg(1)%qy)
        write(iso,'(2x,a,f8.5)') 'q_y=',ddmrg(1)%qy
        return
      end if

! --- DDMRG
      if(index(para,'lower bound').ne.0) then
        i0=index(para,'=')+1
        call pcal(para(i0:i1),ddmrg(1)%wmin)
        return
      end if

      if(index(para,'upper bound').ne.0) then
        i0=index(para,'=')+1
        call pcal(para(i0:i1),ddmrg(1)%wmax)
        return
      end if

      if(index(para,'number of points').ne.0) then
        i0=index(para,'=')+1
        read(para(i0:i1),*) ddmrg(1)%nw
        return
      end if

      if(index(para,'half width of delta function').ne.0) then
        i0=index(para,'=')+1
        call pcal(para(i0:i1),ddmrg(1)%sigma)
        return
      end if

      return
      end
