      subroutine trans_operators(ise,nx,mhx)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ise,nx,ib,jb,ix1,ix2,iop0,i1,i2,jsta,jend,ista,iend,
     &           ksta,kend,isize,jsize,ksize,mhx,jse
      integer,allocatable :: lsta(:),lend(:)
#ifdef cmplx_v
      complex(8),
#else
      real(8),
#endif
     &  allocatable :: hsm(:,:)

! --- CONFIMATION 'jb'
      call conf_block(ise,nx,mhx)

! --- HAMILTONIAN
      jse=mod(ise,2)+1
      do ib=block(ise,nx,mhx)%isbk,block(ise,nx,mhx)%iebk
        allocate(ast(nfr,2),lsta(nfr),lend(nfr))
        do i1=1,nfr
          call para_range(1,block(ise,nx,mhx)%sizex(ib,i1),
     &                    np_env,myid_env,lsta(i1),lend(i1))
          allocate(ast(i1,1)%ht(lsta(i1):lend(i1),
     &                          block(ise,nx,mhx)%size0(ib)))
!$OMP PARALLEL WORKSHARE
          ast(i1,1)%ht=zero
!$OMP END PARALLEL WORKSHARE
        enddo

! ---- INTERACTION TERMS
        do iop0=ista_int,iend_int
          if(th(1)%kh(iop0).eq.0) then
            do i1=1,nfr
              jb=block(ise,nx,mhx)%nse(ib,i1)
              if(jb.eq.0) cycle
! ----- BLOCK HAMILTONIAN
              call trans_set_bk(block(ise,nx-1,mhx)%b(jb)%hm,
     &                          ise,jse,ib,i1,nx,mhx,lsta,lend)

! ------ MAGNETIC FIELD
              if(allocated(fmag)) then
                call trans_set_mag(block(ise,nx-1,mhx)%b(jb)%hm,
     &                             ise,jse,ib,i1,nx,mhx,lsta,lend)
              end if
            enddo

! ------ INTERACTIONS BETWEEN BLOCK AND ADDED-SITE
          elseif(th(1)%kh(iop0).eq.ise) then
            call trans_set_op(ise,nx,mhx,ib,iop0,lsta,lend,0)

! ----- POTENTIAL TERMS AT ADDED SITE
          elseif(th(1)%kh(iop0).eq.6+ise) then
            do i1=1,nfr
              i2=kop(ise,iop0)%io(i1)
              if(i2.eq.0) cycle
              if(block(ise,nx,mhx)%nse(ib,i2).ne.0) then
!$OMP PARALLEL DO
                do ix1=lsta(i2),lend(i2)
                  ast(i2,1)%ht(ix1,ix1+block(ise,nx,mhx)%stax(ib,i1)-1)
     &           =ast(i2,1)%ht(ix1,ix1+block(ise,nx,mhx)%stax(ib,i1)-1)
     &            +kop(ise,iop0)%vo(i1)
                enddo
              end if
            enddo
          end if
        enddo

        do i1=1,nfr
          allocate(ast(i1,2)%ht(lsta(i1):lend(i1),
     &                          block(ise,nx,mhx)%size0(ib)))
          call mpi_allreduce(ast(i1,1)%ht,ast(i1,2)%ht,
     &             (lend(i1)-lsta(i1)+1)*block(ise,nx,mhx)%size0(ib),
     &             mpi_kv,mpi_sum,newcomm_int,ierr)
          deallocate(ast(i1,1)%ht)
        enddo

        call para_range(1,block(ise,nx,mhx)%size(ib),np_vec,
     &                  myid_vec,jsta,jend)
        call para_range(1,block(ise,nx,mhx)%size(ib),np_(ise),
     &                  myid_(ise),ista,iend)

        allocate(hsm(block(ise,nx,mhx)%size(ib),
     &               block(ise,nx,mhx)%size(ib)))
        call trabset(ise,ib,ib,hsm,nx,mhx,one)

        call para_range(jsta,jend,np_(jse),myid_(jse),ksta,kend)
        if(ise.eq.1) then
          allocate(block(ise,nx,mhx)%b(ib)%hm(ista:iend,ksta:kend))
!$OMP PARALLEL DO
          do ix2=ksta,kend
            do ix1=ista,iend
              block(ise,nx,mhx)%b(ib)%hm(ix1,ix2)=hsm(ix1,ix2)
            enddo
          enddo
        elseif(ise.eq.2) then
          allocate(block(ise,nx,mhx)%b(ib)%hm(ksta:kend,ista:iend))
!$OMP PARALLEL DO
          do ix2=ista,iend
            do ix1=ksta,kend
              block(ise,nx,mhx)%b(ib)%hm(ix1,ix2)=hsm(ix1,ix2)
            enddo
          enddo
        end if
        mem_hm=mem_hm+size(block(ise,nx,mhx)%b(ib)%hm)
        deallocate(hsm,ast,lsta,lend)
      enddo

      do ib=1,nbk
        call para_ranges(1,block(ise,nx,mhx)%size(ib),np_vec,
     &                   myid_vec,jsta,jend,jsize)
        call para_ranges(jsta,jend,np_(jse),myid_(jse),
     &                   ksta,kend,ksize)
        call para_ranges(1,block(ise,nx,mhx)%size(ib),np_(ise),
     &                   myid_(ise),ista,iend,isize)

        if(.not.allocated(block(ise,nx,mhx)%b(ib)%hm)) then
          if(ise.eq.1) then
            allocate(block(ise,nx,mhx)%b(ib)%hm(ista:iend,ksta:kend))
          else
            allocate(block(ise,nx,mhx)%b(ib)%hm(ksta:kend,ista:iend))
          end if
          mem_hm=mem_hm+size(block(ise,nx,mhx)%b(ib)%hm)
        end if

        if(np_bk.gt.1) then
          call mpi_bcast(block(ise,nx,mhx)%b(ib)%hm,isize*ksize,
     &                   mpi_kv,kid0(ib),newcomm_bk,ierr)
        end if

! --- DATA SYNCHRONIZATION
        if(np_add.gt.1) then
          call mpi_bcast(block(ise,nx,mhx)%b(ib)%hm,isize*ksize,
     &                   mpi_kv,0,newcomm_add,ierr)
        end if
        if(np_int.gt.1) then
          call mpi_bcast(block(ise,nx,mhx)%b(ib)%hm,isize*ksize,
     &                   mpi_kv,0,newcomm_int,ierr)
        end if
      enddo


      return
      end
