      subroutine trans_wfunc2(idt,mhx)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: idt,mhx,ib,jb,lb,i,k,lsta,lend,lsize,ih
#ifdef cmplx_v
      complex(8),
#else
      real(8),
#endif
     &  allocatable :: uv0(:,:),uvt(:,:)

      ih=1

      if(mdDMRG.eq.1.and.allocated(vx)) then
        call mpi_uv_wf(2,nse(2)+1)   !TRANSFORMATION MATRIX

        do ib=isbk1,iebk1
          do i=1,nfrx(1)
            do k=1,nfrx(2)
              jb=bk(ib,1,ih)%ap(ad(i,k))%nse(1)

              if(jb.eq.0) cycle

              if(nas*nae.eq.0) then
                if(.not.allocated(vx(jb)%jlb)) then
                  if(bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1.eq.0.or.
     &               bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1.eq.0) cycle
                    call irand_el(v(ib,idt)%ap(ad(i,k))%b,
     &                            size(v(ib,idt)%ap(ad(i,k))%b))
                  cycle
                end if
                lb=vx(jb)%jlb(1)
              else
                lb=vx(jb)%jlb(i)
              end if

              if(lb.eq.0.or.lb.gt.block(2,nse(2)+1,mhx)%nbk) cycle

              allocate(uv0(bk(ib,2,ih)%ivs(k):bk(ib,2,ih)%ive(k),
     &                 block(2,nse(2)+1,mhx)%size0(lb)))

              if(nae.eq.0) then
                call gr2d(block(2,nse(2)+1,mhx)%b(lb)%s(i)%uv,
     &                    (bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1)
     &                    *block(2,nse(2)+1,mhx)%isize0(lb,1),
     &                    uv0,np_sys,newcomm_sys)
              else
                call gr2d(block(2,nse(2)+1,mhx)%b(lb)%s(k)%uv,
     &                    (bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1)
     &                    *block(2,nse(2)+1,mhx)%isize0(lb,1),
     &                    uv0,np_sys,newcomm_sys)
              end if

              if((bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &          *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1)
     &          *block(2,nse(2)+1,mhx)%size(lb).gt.0) then

                if(nae.eq.0) then
                  call XGEMM(chmm(1),chmm(2),
     &                 bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1,
     &                 bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1,
     &                 block(2,nse(2)+1,mhx)%size(lb),
     &                 one,
     &                 vx(jb)%ap(1)%b,
     &                 bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1,
     &                 uv0,
     &                 bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1,
     &                 zero,
     &                 v(ib,idt)%ap(ad(i,k))%b,
     &                 bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
                else
                  call XGEMM(chmm(1),chmm(2),
     &                 bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1,
     &                 bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1,
     &                 block(2,nse(2)+1,mhx)%size(lb),
     &                 one,
     &                 vx(jb)%ap(i)%b,
     &                 bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1,
     &                 uv0,
     &                 bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1,
     &                 zero,
     &                 v(ib,idt)%ap(ad(i,k))%b,
     &                 bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
                end if
              end if

              deallocate(uv0)

            enddo
          enddo
        enddo

        deallocate(vx) !deallocate temporary array of wavefunction

        call dealc_block(2) !deallocate environment block

        if(w_nz.gt.1.d-15) call noize_wf() ! INTRODUCING NOIZE TO TRANSFORMED WAVEFUNCTION

      elseif(mdDMRG.eq.2.and.allocated(vx)) then
        call mpi_uv_wf(1,nse(1)+1)

        do ib=isbk1,iebk1
          do k=1,nfrx(2)
            do i=1,nfrx(1)
              lb=bk(ib,1,ih)%ap(ad(i,k))%nse(2)
              if(lb.eq.0) cycle

              if(nas*nae.eq.0) then
                if(.not.allocated(vx(lb)%jlb)) then
                  cycle
                end if
                jb=vx(lb)%jlb(1)
              else
                jb=vx(lb)%jlb(k)
              end if

              if(jb.eq.0) cycle

              call para_range(1,bk(ib,1,ih)%sizex(i),
     &                        np_env,myid_env,lsta,lend)
              lsize=lend-lsta+1
              allocate(uv0(bk(ib,1,ih)%sizex(i),
     &                     block(1,nse(1)+1,mhx)%ista0(jb,1):
     &                     block(1,nse(1)+1,mhx)%iend0(jb,1)))

              if(nas.eq.0) then
                call gc2d(block(1,nse(1)+1,mhx)%b(jb)%s(k)%uv,
     &                    lsize,block(1,nse(1)+1,mhx)%isize0(jb,1),
     &                    uv0,bk(ib,1,ih)%sizex(i),
     &                    np_env,newcomm_env)
              else
                call gc2d(block(1,nse(1)+1,mhx)%b(jb)%s(i)%uv,
     &                    lsize,block(1,nse(1)+1,mhx)%isize0(jb,1),
     &                    uv0,bk(ib,1,ih)%sizex(i),
     &                    np_env,newcomm_env)
              end if

              allocate(uvt(block(1,nse(1)+1,mhx)%stax(jb,i):
     &                     block(1,nse(1)+1,mhx)%stax(jb,i)
     &                     +bk(ib,1,ih)%sizex(i)-1,
     &                     block(1,nse(1)+1,mhx)%size0(jb)))

              call gr2d(uv0,bk(ib,1,ih)%sizex(i)
     &                  *block(1,nse(1)+1,mhx)%isize0(jb,1),
     &                  uvt,np_sys,newcomm_sys)

              deallocate(uv0)

              if((bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &          *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1)
     &          *block(1,nse(1)+1,mhx)%size(jb).ne.0) then

                if(nas*nae.eq.0) then
                  call XGEMM(chmm(1),chmm(1),
     &                 bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1,
     &                 bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1,
     &                 block(1,nse(1)+1,mhx)%size(jb),
     &                 one,
     &                 uvt(bk(ib,1,ih)%ivs(i)
     &                       +block(1,nse(1)+1,mhx)%stax(jb,i)-1,1),
     &                 bk(ib,1,ih)%sizex(i),
     &                 vx(lb)%ap(1)
     &                 %b(:,bk(ib,2,ih)%ivs(k):bk(ib,2,ih)%ive(k)),
     &                 block(1,nse(1)+1,mhx)%size(jb),
     &                 zero,
     &                 v(ib,idt)%ap(ad(i,k))%b,
     &                 bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
                else
                  call XGEMM(chmm(1),chmm(1),
     &                 bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1,
     &                 bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1,
     &                 block(1,nse(1)+1,mhx)%size(jb),
     &                 one,
     &                 uvt(bk(ib,1,ih)%ivs(i)
     &                       +block(1,nse(1)+1,mhx)%stax(jb,i)-1,1),
     &                 bk(ib,1,ih)%sizex(i),
     &                 vx(lb)%ap(k)
     &                 %b(:,bk(ib,2,ih)%ivs(k):bk(ib,2,ih)%ive(k)),
     &                 block(1,nse(1)+1,mhx)%size(jb),
     &                 zero,
     &                 v(ib,idt)%ap(ad(i,k))%b,
     &                 bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
                end if
              end if

              deallocate(uvt)

            enddo
          enddo
        enddo

        deallocate(vx)

        call dealc_block(1) !deallocate system block

        if(w_nz.gt.1.d-15) call noize_wf() ! INTRODUCING NOIZE TO TRANSFORMED WAVEFUNCTION
      else
        call irandvec(v(:,idt))
      end if

      call normalize(v(:,idt))

      return
      end
