      subroutine update_data()
      use mod_dmrg
      implicit none
      include 'mpif.h'
      real(8) :: dmem_uv,dmem_max_uv,
     &           dmem_ts,dmem_max_ts,
     &           dmem_op,dmem_max_op,
     &           dmem_hm,dmem_max_hm,
     &           rsc_mem
      integer :: ise,nx

      time(4)=mpi_wtime()

! --- MODE OF DMRG (0:extend,1:right,2:left,3:extend(odd case)
      if(idmrg.lt.ndmrg_i) then
        if(idmrg.eq.ndmrg_i-1.and.mod(nsite,2).eq.1) then
          mdDMRG=3
        end if
      elseif(idmrg.eq.ndmrg_i) then
        mdDMRG=1
        if(nse(2).le.ls_r) then
          mdDMRG=2
        end if
      else
        if(nse(2).eq.ls_r) then
          mdDMRG=2
        elseif(nse(1).eq.ls_l) then
          mdDMRG=1
        end if
      end if

! --- FLAG OF WAVEFUNCTION TRANSFORMATION
      if(iwf.lt.0.and.(idmrg-ndmrg_i)/ndmrg_s.eq.abs(iwf)) iwf=1

! --- SET WORKING ARRAY(NUMBER OF BLOCK)
      allocate(kid_old(nbk,2))
!$OMP PARALLEL
!$OMP WORKSHARE
      kid_old(:,1)=kid0
!$OMP END WORKSHARE NOWAIT
      if(isbk0.gt.1) then
!$OMP WORKSHARE
        kid_old(1:isbk0-1,2)=-1
!$OMP END WORKSHARE NOWAIT
      end if
!$OMP WORKSHARE
      kid_old(isbk0:iebk0,2)=kid1
!$OMP END WORKSHARE NOWAIT
      if(iebk0.lt.nbk) then
!$OMP WORKSHARE
        kid_old(iebk0+1:nbk,2)=-1
!$OMP END WORKSHARE
      end if
!$OMP END PARALLEL

! --- UPDATE BASIS SET
      if(mdDMRG.eq.0.or.mdDMRG.eq.1.or.mdDMRG.eq.3) then !SYSTEM BLOCK
        if(nh.eq.1.or.id_mapping.eq.0) then
          call update_basis(1,nse(1)+1,mh,1,ntargd,id_hop,1)
        else
          call update_bmap(1)
        end if
        if(id_fast.eq.1) call make_uvf(1,nse(1)+1)
      end if

      if(mdDMRG.eq.0.or.mdDMRG.eq.2) then !ENVIRONMENT BLOCK
        if(nh.eq.1.or.id_mapping.eq.0) then
          call update_basis(2,nse(2)+1,mh,1,ntargd,id_hop,1)
        else
          call update_bmap(2)
        end if
        if(id_fast.eq.1) call make_uvf(2,nse(2)+1)
      end if


! --- COPY BASIS SET (USE MAPPING SPACE)
      if(if_tdmrg*iphys*id_mapping.ne.0) then
        call change_space(2)
        do ise=1,2
          do nx=2,nsite-naddf-1
            call copy_block(ise,block(ise,nx,2),block(ise,nx,1))
          enddo
        enddo
      end if

! --- SET NUMBER OF SITES IN SYSTEM AND ENVIRONMENT BLOCKS
      if(idmrg.lt.ndmrg_i) then
        nse(1)=nse(1)+1
        nse(2)=nse(2)+1
        if(idmrg.eq.ndmrg_i-1.and.mod(nsite,2).eq.1) then
          nse(2)=nse(2)-1
        end if
        limup=max(min(1,inup),
     &           int(dble(inup)*dble(nse(1)+nse(2)+2)/dble(nsite)))
        limdw=max(min(1,indw),
     &           int(dble(indw)*dble(nse(1)+nse(2)+2)/dble(nsite)))
      elseif(idmrg.eq.ndmrg_i) then
        if(mdDMRG.eq.1) then
          if(naddf.eq.1) then
            nas=1
            nae=0
            nadd=nas+nae
          end if
          nse(1)=nse(1)+nas
          nse(2)=nse(2)-nae
        else
          if(naddf.eq.1) then
            nas=0
            nae=1
            nadd=nas+nae
          end if
          nse(1)=nse(1)-nas
          nse(2)=nse(2)+nae
        end if
        limup=inup
        limdw=indw
      else
        if(naddf.eq.1) then
          if(nse(2).eq.ls_r+1) then
            nas=0
            nae=1
          elseif(nse(1).eq.ls_l+1) then
            nas=1
            nae=0
          end if
        end if

        if(mdDMRG.eq.1) then
          nse(1)=nse(1)+1
          nse(2)=nse(2)-1
        else
          nse(1)=nse(1)-1
          nse(2)=nse(2)+1
        end if
      end if

! --- OUTPUT DATA OF EACH DMRG STEPS
      if(myid_dmrg.eq.0) then
        if(mdDMRG.eq.0.or.mdDMRG.eq.3) then
          write(99,'(a,1x,I6,1x,f15.8,1x,f12.8,1x,e17.8)') 
     &      'I',idmrg,ene_t,ee_t,err_t
        elseif(if_tdmrg.eq.1) then
          write(99,'(a,1x,I6,1x,f15.8,1x,f12.8,1x,e17.8)') 
     &      'T',idmrg,ene_t,ee_t,err_t
        elseif(ntargd.gt.1) then
          write(99,'(a,1x,I6,1x,f15.8,1x,f12.8,1x,e17.8)') 
     &      'M',idmrg,ene_t,ee_t,err_t
        else
          write(99,'(a,1x,I6,1x,f15.8,1x,f12.8,1x,e17.8)') 
     &      'F',idmrg,ene_t,ee_t,err_t
        end if
      end if

! --- WAVEFUNCTION TRANSFORMATION (1/2)
      if(iphys*id_mapping*if_tdmrg.eq.1) then
        call trans_wfunc1(2,1)
      elseif(idmrg.ne.ndmrg_i) then
        call trans_wfunc1(1,1)
      end if

! --- OUTPUT USAGE MEMORY SIZE
      rsc_mem=1.d-6 !MB order
#ifdef cmplx_v
      rsc_mem=2.d0*rsc_mem !complex case
#endif
      dmem_uv=dble(mem_uv)*rsc_mem*8.d0
      call mpi_allreduce(dmem_uv,dmem_max_uv,1,mpi_double_precision,
     &                   mpi_max,newcomm_dmrg,ierr)
      dmem_hm=dble(mem_hm)*rsc_mem*8.d0
      call mpi_allreduce(dmem_hm,dmem_max_hm,1,mpi_double_precision,
     &                   mpi_max,newcomm_dmrg,ierr)
      dmem_ts=dble(mem_ts)*rsc_mem
      call mpi_allreduce(dmem_ts,dmem_max_ts,1,mpi_double_precision,
     &                   mpi_max,newcomm_dmrg,ierr)
      dmem_op=dble(mem_op)*rsc_mem
      call mpi_allreduce(dmem_op,dmem_max_op,1,mpi_double_precision,
     &                   mpi_max,newcomm_dmrg,ierr)
      mem_op=0
      time(5)=mpi_wtime()
      if(myid_dmrg.eq.key_rank) then
        write(iso,'(1x,a)') '# used memory size (node):'
        write(iso,'(2x,a,f10.3,a)')
     &    '(transformation matrix):',dmem_max_uv,' [MB]'
        write(iso,'(2x,a,f10.3,a)')
     &    '(Hamiltonian):          ',dmem_max_hm,' [MB]'
        write(iso,'(2x,a,f10.3,a)')
     &    '(target states):        ',dmem_max_ts,' [MB]'
        write(iso,'(2x,a,f10.3,a)')
     &    '(operators):            ',dmem_max_op,' [MB]'

        write(iso,'(1x,a)') '# elapsed time:'
        write(iso,'(2x,a,f15.3,a)')
     &    '(initialization):  ',time(2)-time(1),' [s]'
        times(1)=times(1)+time(2)-time(1)
        write(iso,'(2x,a,f15.3,a)')
     &    '(Hamiltonian):     ',time(3)-time(2),' [s]'
        times(2)=times(2)+time(3)-time(2)
        write(iso,'(2x,a,f15.3,a)')
     &    '(target state):    ',time(4)-time(3),' [s]'
        times(3)=times(3)+time(4)-time(3)
        write(iso,'(2x,a,f15.3,a)')
     &    '(density matrix):  ',time(5)-time(4),' [s]'
        times(4)=times(4)+time(5)-time(4)
        write(iso,'(2x,a,f21.3,a)')
     &    '(total):     ',time(5)-time(1),' [s]'
        times(5)=times(5)+time(5)-time(1)
      end if

c --- DEALLOCATE WORKING ARRAYS
      deallocate(kid0,kid1,kid_old,bk,kop,th,bmpi,ad)
      if(allocated(v)) deallocate(v)
      if(allocated(pop)) deallocate(pop)

      return
      end
