      subroutine use_input(id)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: id,i,ios,md,isy,ict,ics,lsx,ip,na4,ix1
      integer,allocatable :: isx(:),is4(:,:)
      real(8),allocatable :: v0(:),v4(:)
      character(256) :: para

! --- COUNTING TERMS
      md=0; ict=0
      if(myid_dmrg.eq.key_rank) then
        open(10,file=file_input,status='old',err=200)
        md=1
        close(10)
      end if
  200 continue

      call mpi_bcast(md,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      if(md.eq.0) goto 100

      if(myid_dmrg.eq.key_rank) then
        open(10,file=file_input,status='old',err=100)
        md=0; ios=0; nsite=0; nh2=0
        allocate(isx(5),v0(5),is4(5,3),v4(3))
        do while(ios.ge.0)
          read(10,'(a)',iostat=ios) para
          if(ios.lt.0) exit
          if(LEN_TRIM(para).eq.0) then
            if(md.eq.0) then
              md=1
              ict=0
            elseif(md.eq.1) then
              md=0
            end if
            cycle
          end if

          ip=index(para,'#')
          if(ip.ne.0) then
            md=2
            cycle
          end if

          if(md.eq.1) then
            ict=ict+1
            read(para,*) isy,v0(1:min(ict,5))
            nsite=max(nsite,isy)
            do i=1,min(ict,5)
              if(abs(v0(i)).gt.0.d0) then
                nh2=nh2+1
              end if
            enddo
          elseif(md.eq.2) then
            is4=0; v4=0.d0
            if(LEN_TRIM(para).eq.0) exit
            read(para,*,iostat=ios) is4(1:5,1),v4(1),is4(1:5,2),v4(2),
     &                              is4(1:5,3),v4(3)
            if(ios.lt.0) then
              read(para,*,iostat=ios) is4(1:5,1),v4(1),is4(1:5,2),v4(2)
              if(ios.lt.0) then
                read(para,*,iostat=ios) is4(1:5,1),v4(1)
                if(ios.lt.0) then
                  exit
                else
                  na4=1
                end if
              else
                na4=2
              end if
            else
              na4=3
            end if
            nh4=nh4+na4
          end if
        enddo
        close(10)

! --- INPUT TERMS
        allocate(hamil(nh2+nh4))
        open(10,file=file_input,status='old',err=100)
        md=0; ios=0; nh2=0; nh4=0; ics=0
        do while(ios.ge.0)
          read(10,'(a)',iostat=ios) para
          if(ios.lt.0) exit
          if(LEN_TRIM(para).eq.0) then
            if(md.eq.0) then
              md=1
              ict=0
            elseif(md.eq.1) then
              md=0
              ics=ics+5
            end if
            cycle
          end if

          ip=index(para,'#')
          if(ip.ne.0) then
            md=2
            cycle
          end if

          if(md.eq.0) then
            lsx=min(nsite,ics+5)-ics
            read(para,*) isx(1:lsx)
          elseif(md.eq.1) then
            ict=ict+1
            read(para,*) isy,v0(1:min(ict,5))
            nsite=max(nsite,isy)
            do i=1,min(ict,5)
              if(abs(v0(i)).gt.0.d0) then
                nh2=nh2+1
                hamil(nh2)%nop=2
                hamil(nh2)%vh(1)=v0(i)
                allocate(hamil(nh2)%ihs(2))
                hamil(nh2)%ihs=(/isx(i),ics+ict/)
              end if
            enddo
          elseif(md.eq.2) then
            is4=0; v4=0.d0
            if(LEN_TRIM(para).eq.0) exit
            read(para,*,iostat=ios) is4(1:5,1),v4(1),is4(1:5,2),v4(2),
     &                              is4(1:5,3),v4(3)
            if(ios.lt.0) then
              read(para,*,iostat=ios) is4(1:5,1),v4(1),is4(1:5,2),v4(2)
              if(ios.lt.0) then
                read(para,*,iostat=ios) is4(1:5,1),v4(1)
                if(ios.lt.0) then
                  exit
                else
                  na4=1
                end if
              else
                na4=2
              end if
            else
              na4=3
            end if

            do i=1,na4
              hamil(nh2+nh4+i)%nop=4
              hamil(nh2+nh4+i)%vh(1)=v4(i)
              allocate(hamil(nh2+nh4+i)%ihs(4))
              if(is4(1,i).le.is4(2,i)) then
                hamil(nh2+nh4+i)%ihs(1)=is4(1,i)
                hamil(nh2+nh4+i)%ihs(2)=is4(2,i)
              else
                hamil(nh2+nh4+i)%ihs(1)=is4(2,i)
                hamil(nh2+nh4+i)%ihs(2)=is4(1,i)
              end if
              if(is4(3,i).le.is4(4,i)) then
                hamil(nh2+nh4+i)%ihs(3)=is4(3,i)
                hamil(nh2+nh4+i)%ihs(4)=is4(4,i)
              else
                hamil(nh2+nh4+i)%ihs(3)=is4(4,i)
                hamil(nh2+nh4+i)%ihs(4)=is4(3,i)
              end if

              if(hamil(nh2+nh4+i)%ihs(1)
     &            .gt.hamil(nh2+nh4+i)%ihs(3)) then
                is4(1,i)=hamil(nh2+nh4+i)%ihs(3)
                is4(2,i)=hamil(nh2+nh4+i)%ihs(4)
                is4(3,i)=hamil(nh2+nh4+i)%ihs(1)
                is4(4,i)=hamil(nh2+nh4+i)%ihs(2)
                hamil(nh2+nh4+i)%ihs(1:4)=is4(1:4,i)
              end if
            enddo
            nh4=nh4+na4
          end if
        enddo
        close(10)

! --- OUTPUT TERMS
        open(10,file='preset_trans.dat')
        if(nh2.gt.0) write(10,'(a)') '# 2'
        do i=1,nh2
          write(10,'(I0,1x,I0,1x,f16.10)')
     &      hamil(i)%ihs(1:2),hamil(i)%vh(1)
        enddo
        if(nh4.gt.0) write(10,'(a)') '# 4'
        do i=nh2+1,nh2+nh4
          write(10,'(I0,1x,I0,1x,I0,1x,I0,1x,f16.10)')
     &      hamil(i)%ihs(1:4),hamil(i)%vh(1)
        enddo
        close(10)
        deallocate(isx,v0,is4,v4)
      end if

      call mpi_bcast(nsite,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(nh2,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(nh4,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      if(myid_dmrg.ne.key_rank) then
        allocate(hamil(nh2+nh4))
        do ix1=1,nh2
          hamil(ix1)%nop=2
         allocate(hamil(ix1)%ihs(2))
        enddo
        do ix1=nh2+1,nh2+nh4
          hamil(ix1)%nop=4
          allocate(hamil(ix1)%ihs(4))
        enddo
      end if
      do ix1=1,nh2
        call mpi_bcast(hamil(ix1)%ihs,2,mpi_integer,key_rank,
     &                 newcomm_dmrg,ierr)
        call mpi_bcast(hamil(ix1)%vh(1),1,mpi_double_precision,
     &                 key_rank,newcomm_dmrg,ierr)
      enddo
      do ix1=nh2+1,nh2+nh4
        call mpi_bcast(hamil(ix1)%ihs,4,mpi_integer,key_rank,
     &                 newcomm_dmrg,ierr)
        call mpi_bcast(hamil(ix1)%vh(1),1,mpi_double_precision,
     &                 key_rank,newcomm_dmrg,ierr)
      enddo

      id=0
      return

  100 continue
      id=1
      return
      end
