      subroutine wfunc_tmat(mhx,iv)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: mhx,iv,ib,jb,kb,i,k,mhc,jsta,jend,jsize,
     &           lsta,lend,lsize,ksta,kend,ksize,ista,iend,isize,
     &           ip,ix1,ix2,ivsta,ivend,ivsize,kvsta,kvend,kvsize,ih
#ifdef cmplx_v
      real(8) :: DZNRM2
      complex(8),
#else
      real(8) :: DNRM2
      real(8),
#endif
     &  allocatable :: v1(:,:),v0(:,:),tm1(:,:)
      real(8) :: aa0,aa

      ih=1

      if(myid_dmrg.eq.key_rank) then
        write(iso,'(1x,a)') '# transformation of wave function'
      end if

      mhc=mod(mhx,2)+1

      aa0=0.d0
C --- SYSTEM BLOCK
      do ib=isbk1,iebk1
        do i=1,nfrx(1)
          do k=1,nfrx(2)
            jb=bk(ib,1,ih)%ap(ad(i,k))%nse(1)
            if(jb.eq.0) cycle
            
            ivsta=bk(ib,1,ih)%ivs(i)
            ivend=bk(ib,1,ih)%ive(i)
            ivsize=bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1
            kvsta=bk(ib,2,ih)%ivs(k)
            kvend=bk(ib,2,ih)%ive(k)
            kvsize=bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1

            allocate(v1(block(1,nse(1),mhc)%size(jb),kvsta:kvend),
     &               tm1(ivsta:ivend,block(1,nse(1),mhc)%size(jb)))

            call para_ranges(1,block(1,nse(1),mhc)%size(jb),np_env,
     &                       myid_env,ista,iend,isize)

            call gr2d(block(1,nse(1),1)%b(jb)%tm(:,ista:iend),
     &                ivsize*isize,tm1,np_env,newcomm_env)

            if(block(1,nse(1),mhc)%size(jb).gt.0.and.
     &         kvsize.gt.0.and.ivsize.gt.0) then

              call XGEMM(chmm(2),chmm(1),
     &               block(1,nse(1),mhc)%size(jb),
     &               kvsize,
     &               ivsize,
     &               one,
     &               tm1,
     &               ivsize,
     &               v(ib,iv)%ap(ad(i,k))%b,
     &               ivsize,
     &               zero,
     &               v1,
     &               block(1,nse(1),mhc)%size(jb))

            else
!$OMP PARALLEL WORKSHARE
              v1=zero
!$OMP END PARALLEL WORKSHARE
            end if

            deallocate(tm1)

            call para_ranges(1,block(1,nse(1),mhc)%size(jb),
     &                       np_sys,myid_sys,jsta,jend,jsize)
            do ix1=iv,ntargd
              deallocate(v(ib,ix1)%ap(ad(i,k))%b)
              allocate(v(ib,ix1)%ap(ad(i,k))%b(jsta:jend,kvsta:kvend))
            enddo

            do ip=1,np_sys
              call para_ranges(1,block(1,nse(1),mhc)%size(jb),
     &                         np_sys,ip-1,ksta,kend,ksize)

              if(ksize*kvsize.gt.0) then
                allocate(v0(ksta:kend,kvsta:kvend))

!$OMP PARALLEL DO
                do ix2=kvsta,kvend
                  do ix1=ksta,kend
                    v0(ix1,ix2)=v1(ix1,ix2)
                  enddo
                enddo

                call mpi_reduce(v0,v(ib,iv)%ap(ad(i,k))%b,ksize*kvsize,
     &                          mpi_kv,mpi_sum,ip-1,newcomm_sys,ierr)

                deallocate(v0)
              end if
            enddo

            deallocate(v1)

! --- CHECK NORM OF TRANSFORMED WAVEFUNCTION
#ifdef cmplx_v
            aa0=aa0+DZNRM2(jsize*kvsize,v(ib,iv)%ap(ad(i,k))%b,1)**2
#else
            aa0=aa0+DNRM2(jsize*kvsize,v(ib,iv)%ap(ad(i,k))%b,1)**2
#endif

          enddo
        enddo
      enddo

      call mpi_allreduce(aa0,aa,1,MPI_REAL8,mpi_sum,newcomm_dmrg,ierr)
      if(myid_dmrg.eq.key_rank) then
        write(iso,'(2x,a,1Pe12.5)') '(Sys. Diff.) = ',1.d0-aa
      end if
      aa0=0.d0

C --- ENVIRONMENT BLOCK
      do ib=isbk1,iebk1
        do i=1,nfrx(1)
          do k=1,nfrx(2)
            jb=bk(ib,1,ih)%ap(ad(i,k))%nse(1)
            kb=bk(ib,1,ih)%ap(ad(i,k))%nse(2)
            if(jb*kb.eq.0) cycle

            ivsta=bk(ib,1,ih)%ivs(i)
            ivend=bk(ib,1,ih)%ive(i)
            ivsize=bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1
            kvsta=bk(ib,2,ih)%ivs(k)
            kvend=bk(ib,2,ih)%ive(k)
            kvsize=bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1

            call para_ranges(1,block(1,nse(1),mhc)%size(jb),
     &                       np_sys,myid_sys,jsta,jend,jsize)

            allocate(v1(jsta:jend,block(2,nse(2),mhc)%size(kb)),
     &               tm1(kvsta:kvend,block(2,nse(2),mhc)%size(kb)))

            call para_ranges(1,block(2,nse(2),mhc)%size(kb),np_sys,
     &                       myid_sys,ista,iend,isize)

            call gr2d(block(2,nse(2),1)%b(kb)%tm(:,ista:iend),
     &                isize*kvsize,
     &                tm1,np_sys,newcomm_sys)

            if(jsize.gt.0.and.kvsize.gt.0.and.
     &         block(2,nse(2),mhc)%size(kb).gt.0) then

              call XGEMM(chmm(1),chmm(1),
     &               jsize,
     &               block(2,nse(2),mhc)%size(kb),
     &               kvsize,
     &               one,
     &               v(ib,iv)%ap(ad(i,k))%b,
     &               jsize,
     &               tm1,
     &               kvsize,
     &               zero,
     &               v1,
     &               jsize)

            else
!$OMP PARALLEL WORKSHARE
              v1=zero
!$OMP END PARALLEL WORKSHARE
            end if

            deallocate(tm1)

            call para_ranges(1,block(2,nse(2),mhc)%size(kb),
     &                       np_env,myid_env,lsta,lend,lsize)

            do ix1=iv,ntargd
              deallocate(v(ib,ix1)%ap(ad(i,k))%b)
              allocate(v(ib,ix1)%ap(ad(i,k))%b(jsta:jend,lsta:lend))
            enddo

            do ip=1,np_env
              call para_ranges(1,block(2,nse(2),mhc)%size(kb),
     &                         np_env,ip-1,ksta,kend,ksize)

              if(jsize*ksize.gt.0) then
                allocate(v0(jsta:jend,ksta:kend))

!$OMP PARALLEL DO
                do ix2=ksta,kend
                  do ix1=jsta,jend
                    v0(ix1,ix2)=v1(ix1,ix2)
                  enddo
                enddo

                call mpi_reduce(v0,v(ib,iv)%ap(ad(i,k))%b,jsize*ksize,
     &                          mpi_kv,mpi_sum,ip-1,newcomm_env,ierr)

                deallocate(v0)
              end if
            enddo

            deallocate(v1)

! --- CHECK NORM OF TRANSFORMED WAVEFUNCTION
#ifdef cmplx_v
            aa0=aa0+DZNRM2(jsize*lsize,v(ib,iv)%ap(ad(i,k))%b,1)**2
#else
            aa0=aa0+DNRM2(jsize*lsize,v(ib,iv)%ap(ad(i,k))%b,1)**2
#endif

          enddo
        enddo
      enddo

      call mpi_allreduce(aa0,aa,1,MPI_REAL8,mpi_sum,newcomm_dmrg,ierr)
      if(myid_dmrg.eq.key_rank) then
        write(iso,'(2x,a,1Pe12.5)') '(Env. Diff.) = ',1.d0-aa
      end if

      return
      end
